/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Common"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Common"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojox.widget.Standby");
dojo.provide("fbfwca.Common");

fbfwca.Common = {

	ShowForm : function (formId, parentId) {
		dojo.style(formId, "display", "block");
		dojo.style(parentId, "display", "none");
	},

	HideForm : function (formId, parentId) {
		dojo.style(formId, "display", "none");
		dojo.style(parentId, "display", "block");
	},
	
	StandbyShow: function(targetId, parentId) {
		//add standby overlay
		console.debug("define standby: targetId:"+targetId+" parentId:"+parentId);
		var node1 = document.createElement('div');
		var standby = new dojox.widget.Standby({target:targetId, id:"standbyAct"}, node1);	
		var pId = parentId;
		var parent;
		if (pId == null)
		{
			var parent = dijit.getEnclosingWidget(dojo.byId(targetId).parentNode);
			pId = parent.id;
		}
		
		dojo.byId(pId).appendChild(standby.domNode);
		console.debug("standby: "+standby);	
		standby.startup();	

		if (standby)
		{
		    console.debug("call standby.show() "+standby);
			standby.show();
			console.debug("Sleep for .2 seconds...");
			java.lang.Thread.currentThread().sleep(200); // must sleep here otherwise no overlay display
		}
		
		return standby;
	},
	
	StandbyHide: function (standby) {
		if (standby)
		{
			console.debug("call standby.hide() "+standby);
			standby.hide();
			dijit.byId('standbyAct').destroy();
		}
	}
};

}
