/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Config"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Config"] = true;
dojo.provide("fbfwca.Config");
dojo.require("fbfwca.Formatters");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");	
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");

fbfwca.Config = {

  CONFIG_INIT : true,
  EMAIL_INIT : false,

	/**************************************************************************
	* Initialize either the notebook or the wizard.
	*
	* Parameter:
	*		obj - key in the properties message file
	*		name - group name
	*		func - 0=create, non-zero=modify
	*		inputdata - data already gotten
	**************************************************************************/
	init : function (obj, name, func, inputdata) 
	{
		console.log(name + " " +  func + " " + inputdata);
		var defaultStorageUnit = 2;
		var data;

		dojo.cookie("FBWRemote_displayed", null, {expires:-1});
		
		if ( name )
		{
			data = fbfwca.ajax.getGroupConfiguration(name);
			if ( name == "default" || func == 0)
				obj.General_group.attr('value', "");
			else
				obj.General_group.attr('value', name);
		}
		else if ( inputdata )
		{
			data = inputdata;
			obj.General_group.attr('value', data.name);
			console.log("data from caller");
		}
		
		// No data available
		if ( data == null)
		{
			console.log("default data");
			obj.General_desc.attr('value', "");
			//obj.Continuous_backupTo.attr('value', "C:\\");
			//obj.Continuous_backupTo.attr('required', true)
			obj.Continuous_versionsKeep.attr('value', "3");	

			obj.Continuous_maxspace.attr('value', 20);
			obj.Continuous_maxspace_unitFS.attr('value', defaultStorageUnit);
			obj.Continuous_protectLevelFS.attr('value', 3);
		  
		  var includes = "\\$(MYDOCUMENTS-SHORT)\\|*.doc|*.xls|*.ppt|*.123";
			obj.Protect_filesFolder.attr('value', includes.replace(/[|]/g,"\n"));
			obj.Protect_exclFilesFolder.attr('value', "");
			obj.Protect_vaulting.attr('value', "");

			obj.Email_applicationFS.attr('value', 0);
			fbfwca.Config.onApplicationFSChanged(obj);
			obj.Email_additionalFolder.attr('value', "");

			obj.Email_versionsKeep.attr('value', "3");	
			obj.Email_schedFrequencyFS.attr('value', "none");
			fbfwca.Config.onSchedFrequencyFSChanged(obj);
			obj.Email_schedDayOfMonthFS.attr('value', 0);
			obj.Email_schedDayOfWeek.attr('value', 0);
			obj.Email_schedTime.attr('value', new Date(0,0,0,0,0,0));
			
			obj.Remote_backupToFS.attr('value', 0);
			obj.Remote_location.attr('value', "");
			fbfwca.Config.setDisabledAttr(obj, true, true);
			obj.Remote_versionsKeep.attr('value', "3");
			obj.Remote_maxspace.attr('value', "20");
			obj.Remote_maxspace_unitFS.attr('value', defaultStorageUnit);
			obj.Remote_encryptRB.attr('checked', false);
			obj.Remote_compressRB.attr('checked', false);

			obj.Remote_subfileCK.attr('value', false);
			obj.Remote_subfile.attr('value', "0");
			obj.Remote_subfile_unitFS.attr('value', 1);

			obj.Advanced_msgPopupCK.attr('value', false);
			obj.Advanced_lockConfigCK.attr('value', false);
	
			obj.Advanced_adminPollRate.attr('value', "1");
			obj.Advanced_adminPollRate_unitFS.attr('value', 0);
		
			obj.Advanced_localQuota.attr('value', "10");
			obj.Advanced_localQuota_unitFS.attr('value', defaultStorageUnit);
			
			obj.Advanced_remoteQuota.attr('value', "10");
			obj.Advanced_remoteQuota_unitFS.attr('value', defaultStorageUnit);
			
			obj.Advanced_maxTransfer.attr('value', "10");
			obj.Advanced_maxTransfer_unitFS.attr('value', 3);
			
		}

		// Data returned from the backend
		else
		{
			obj.General_desc.attr('value', data.description);
			//obj.Continuous_backupTo.attr('value', data.localTarget);
			obj.Continuous_versionsKeep.attr('value', data.localVersions);	

			var out = fbfwca.Formatters.ConvertStorageValue(data.localPoolQuota);
			obj.Continuous_maxspace.attr('value', out.value);
			obj.Continuous_maxspace_unitFS.attr('value', out.unit);
			obj.Continuous_protectLevelFS.attr('value', data.protection);
			delete out;
			obj.Protect_filesFolder.attr('value', data.includeList.replace(/[|]/g,"\n"));
			obj.Protect_exclFilesFolder.attr('value', data.excludeList.replace(/[|]/g,"\n"));
			obj.Protect_vaulting.attr('value', data.vaultList.replace(/[|]/g,"\n"));

			var selection = fbfwca.Config.getEmailAppFromIncludes(data.bitmapList, false);
			obj.Email_applicationFS.attr('value', selection);
			if ( selection == 5 )
			{
				obj.Email_dataFolder.attr('value', data.bitmapList);
				fbfwca.Config.EMAIL_INIT = true;
			}
			obj.Email_additionalFolder.attr('value', data.scheduleList.replace(/[|]/g,"\n"));

			obj.Email_versionsKeep.attr('value', data.emailVersions);	
			var schedule = fbfwca.Config.targetBackupTimeToSchedule(data.scheduleTime, data.scheduleInterval);
			obj.Email_schedFrequencyFS.attr('value', schedule.frequency);
			fbfwca.Config.onSchedFrequencyFSChanged(obj);
			obj.Email_schedDayOfMonthFS.attr('value', schedule.dayOfMonth);
			obj.Email_schedDayOfWeek.attr('value', schedule.dayOfWeek);
			obj.Email_schedTime.attr('value', new Date(0,0,0,0,0, schedule.time));
			delete schedule;
			
			obj.Remote_backupToFS.attr('value', fbfwca.Config.getTargetType(data.remoteTarget));
			//if (obj.Remote_backupToFS.attr('value') == 0 )
			//	fbfwca.Config.setDisabledAttr(obj, true, true);
			obj.Remote_location.attr('value', data.remoteTarget);
			obj.Remote_versionsKeep.attr('value', data.remoteVersions);

			out = fbfwca.Formatters.ConvertStorageValue(data.remotePoolQuota);
			obj.Remote_maxspace.attr('value', out.value);
			obj.Remote_maxspace_unitFS.attr('value', out.unit);
			delete out;
			if ( data.encryptionOn == 0 )
				obj.Remote_encryptRB.attr('checked', false);
			else
				obj.Remote_encryptRB.attr('checked', true);
				
			if ( data.compressionOn == 0 )
				obj.Remote_compressRB.attr('checked', false);
			else
				obj.Remote_compressRB.attr('checked', true);
			
			if ( fbfwca.Config.isThresholdValue(data.subfileThreshold) )
			{
				obj.Remote_subfileCK.attr('value', false);
				obj.Remote_subfile.attr('disabled', true);
				obj.Remote_subfile_unitFS.attr('disabled', true);
				obj.Remote_subfile.attr('value', "0");
				obj.Remote_subfile_unitFS.attr('value', 1);
			}
			else
			{
				obj.Remote_subfileCK.attr('value', true);
				out = fbfwca.Formatters.ConvertStorageValue(data.subfileThreshold);
				obj.Remote_subfile.attr('disabled', false);
				obj.Remote_subfile_unitFS.attr('disabled', false);
				obj.Remote_subfile.attr('value', out.value);
				obj.Remote_subfile_unitFS.attr('value', out.unit);
				delete out;
			}
			
			// After data has been set, now make sure disabled attrib are corrected set
			//fbfwca.Config.onRemote_backupToFSChanged(obj, false, true);
      if (obj.Remote_location.attr('value') == "" )			
        fbfwca.Config.CONFIG_INIT = false;
      else
        fbfwca.Config.CONFIG_INIT = true;
			        
			if (data.stealthMode == 1)
				obj.Advanced_msgPopupCK.attr('value', true);
			else
				obj.Advanced_msgPopupCK.attr('value', false);
			
			if ( data.lockConfig == 1 )
				obj.Advanced_lockConfigCK.attr('value', true);
			else
				obj.Advanced_lockConfigCK.attr('value', false);

			out = this.ConvertPollRate(data.adminPollRate);
			obj.Advanced_adminPollRate.attr('value', out.value);
			obj.Advanced_adminPollRate_unitFS.attr('value', out.unit);
			delete out;
			
			out = fbfwca.Formatters.ConvertStorageValue(data.localFileSizeLimit);
			obj.Advanced_localQuota.attr('value', out.value);
			obj.Advanced_localQuota_unitFS.attr('value', out.unit);
			delete out;
			
			out = fbfwca.Formatters.ConvertStorageValue(data.remoteFileSizeLimit);
			obj.Advanced_remoteQuota.attr('value', out.value);
			obj.Advanced_remoteQuota_unitFS.attr('value', out.unit);
			delete out;
			
			out = fbfwca.Formatters.ConvertThrottleValue(data.remoteThrottle);
			obj.Advanced_maxTransfer.attr('value', out.value);
			obj.Advanced_maxTransfer_unitFS.attr('value', out.unit);
			delete out;
		}
		
		console.log("exit config.init");
	},

	/**************************************************************************
	* Returns the config data in a properties list.
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	getConfigData: function(obj)
	{
		var data = new Object();
		data.name = obj.General_group.attr('value');
		data.description = obj.General_desc.attr('value');
		//data.localTarget = obj.Continuous_backupTo.attr('value');
		data.localVersions = obj.Continuous_versionsKeep.attr('value');
		data.localPoolQuota = fbfwca.Formatters.ConvertStorageValueToBytes(obj.Continuous_maxspace.attr('value'),
																														obj.Continuous_maxspace_unitFS.attr('value'));
		data.protection	= parseInt(obj.Continuous_protectLevelFS.attr('value'));
		    
		data.includeList = obj.Protect_filesFolder.attr('value').replace(/[\n]/g,"|");
		data.excludeList = obj.Protect_exclFilesFolder.attr('value').replace(/[\n]/g,"|");
		data.vaultList = obj.Protect_vaulting.attr('value').replace(/[\n]/g,"|");

		data.bitmapList = obj.Email_dataFolder.attr('value');
		data.scheduleList = obj.Email_additionalFolder.attr('value').replace(/[\n]/g,"|");
		data.emailVersions = obj.Email_versionsKeep.attr('value');	
		
		data.scheduleInterval = obj.Email_schedFrequencyFS.attr('value');
		var schedule = new Object();
    schedule.frequency = data.scheduleInterval;
    schedule.dayOfMonth = parseInt(obj.Email_schedDayOfMonthFS.attr('value'));
    schedule.dayOfWeek = parseInt(obj.Email_schedDayOfWeek.attr('value'));
    
    var hours = obj.Email_schedTime.attr('value').getHours();
    var minutes = obj.Email_schedTime.attr('value').getMinutes();
    schedule.time = (minutes*60) + (hours*60*60);
		data.scheduleTime = fbfwca.Config.scheduleToTargetBackupTime(schedule);
		delete schedule;
		
		data.remoteTarget =	obj.Remote_location.attr('value');
		data.remoteVersions =	obj.Remote_versionsKeep.attr('value');
			
		data.remotePoolQuota = fbfwca.Formatters.ConvertStorageValueToBytes(obj.Remote_maxspace.attr('value'),
																														obj.Remote_maxspace_unitFS.attr('value'));

		if ( obj.Remote_encryptRB.attr('checked') )
			data.encryptionOn = 1;
		else
			data.encryptionOn = 0;
		
		if ( obj.Remote_compressRB.attr('checked') )
			data.compressionOn = 1;
		else
			data.compressionOn = 0;

		if ( obj.Remote_subfileCK.attr('value') )			
		{
			data.subfileThreshold = fbfwca.Formatters.ConvertStorageValueToBytes(obj.Remote_subfile.attr('value'),
													obj.Remote_subfile_unitFS.attr('value'));
		}
		else
		{
			data.subfileThreshold = 1099511627776;
		}
		
		if ( obj.Advanced_msgPopupCK.attr('value') )
			data.stealthMode = 1
		else
			data.stealthMode = 0;
		
		if (obj.Advanced_lockConfigCK.attr('value') )
			data.lockConfig = 1;
		else
			data.lockConfig = 0;

		data.adminPollRate = this.GetPollRate(obj.Advanced_adminPollRate.attr('value'),
											obj.Advanced_adminPollRate_unitFS.attr('value'));
													
		data.localFileSizeLimit =	fbfwca.Formatters.ConvertStorageValueToBytes(obj.Advanced_localQuota.attr('value'),
																														obj.Advanced_localQuota_unitFS.attr('value'));
		data.remoteFileSizeLimit =	fbfwca.Formatters.ConvertStorageValueToBytes(obj.Advanced_remoteQuota.attr('value'),
																														obj.Advanced_remoteQuota_unitFS.attr('value'));
		data.remoteThrottle =	fbfwca.Formatters.ConvertThrottleValueToKilobits(obj.Advanced_maxTransfer.attr('value'),
																														obj.Advanced_maxTransfer_unitFS.attr('value'));
		
		return data;
	},
	
	/**************************************************************************
	* Handles selection changes for Continuous protection level filtering select
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	/*
	onProtectLevelFSChanged : function (obj)
	{
		var selection = obj.Continuous_protectLevelFS.attr('value');
		var required = true;
		if ( selection == 0 || selection == 2 )
		{
			required = false;
			obj.Continuous_backupTo.promptMessage = null;
		}
		dijit.hideTooltip(obj.Continuous_backupTo.domNode);
		obj.Continuous_backupTo.attr('required', required);

	},
	*/
	
	/**************************************************************************
	* Handles selection changes for Email application filtering select
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	onApplicationFSChanged : function (obj)
	{
		var emailAppList = [ 
			{app: "Select Application", includes: "", disable: true},
			{app: "Lotus Notes", includes: "*.id|*.nsf", disable: true},
			{app: "Microsoft Outlook", includes: "*.pst", disable: true},
			{app: "Microsoft Outlook Express 5.5, 6", includes: "*.mbx|*.dbx", disable: true},
			{app: "All", includes: "*.id|*.nsf|*.pst|*.mbx|*.dbx", disable: true},
			{app: "Other", includes: "*.id|*.nsf|*.pst|*.mbx|*.dbx", disable: false}
		];
	
		var selection = obj.Email_applicationFS.attr('value');

    if (fbfwca.Config.EMAIL_INIT)
	    fbfwca.Config.EMAIL_INIT = false;
	  else
      obj.Email_dataFolder.attr('value', emailAppList[selection].includes);

		obj.Email_dataFolder.attr('disabled', emailAppList[selection].disable);
	},
		
	/**************************************************************************
	* Handles selection changes for Email protection frequency filtering select
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	onSchedFrequencyFSChanged : function (obj) 
	{
		var selection = obj.Email_schedFrequencyFS.attr('value');

		if ( selection == "none" || selection == "hourly" )
		{
			dojo.style(obj.Email_dynamicArea, 'display', 'none');
			return;
		}

		dojo.style(obj.Email_dynamicArea, 'display', 'block');
		dojo.style(obj.Email_schedTime, 'display', 'block');
		
		// Schedule monthly
		if ( selection == "monthly" )
		{
			dojo.style(obj.Email_schedMonthly, 'display', 'block');
			dojo.style(obj.Email_schedWeekly, 'display', 'none');
		}

		// Schedule weekly
		else if ( selection == "weekly" )
		{
			dojo.style(obj.Email_schedMonthly, 'display', 'none');
			dojo.style(obj.Email_schedWeekly, 'display', 'block');
		}

		// Schedule daily
		else
		{
			dojo.style(obj.Email_schedMonthly, 'display', 'none');
			dojo.style(obj.Email_schedWeekly, 'display', 'none');
		}
		
	},

	/**************************************************************************
	* Handles selection changes for Remote backup to filtering select
	*
	* Parameter:
	*		obj - notebook object or wizard object
	*		warningMsg - true=display warning message
	**************************************************************************/	
	onRemote_backupToFSChanged : function (obj, warningMsg)
	{
		var NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
		var selection = obj.Remote_backupToFS.attr('value');
		var msgDlg = null;
		var msg = false;

		var remoteList = [ 
			{to: "None Selected", location: "", disable: true, advanced: true},
			{to: "External Device", location: "E:\\", disable: false, advanced: false},
			{to: "File Server", location: "\\\\MyServer\\MyShare", disable: false, advanced: false},
			{to: "Tivoli Storage Manager", location: "tsm://Host.com", disable: false, advanced: true},
			{to: "Web Server (WebDAV)", location: "https://MyISP.com/MyAcct", disable: false, advanced: false}
		];
		
		if ( !warningMsg ) {
			if ( !fbfwca.Config.CONFIG_INIT ) {
			  obj.Remote_location.attr('value', remoteList[selection].location);
			  msg = true;
			}
			fbfwca.Config.CONFIG_INIT = false;
    }
    else if ( !fbfwca.Config.CONFIG_INIT ) {
			obj.Remote_location.attr('value', remoteList[selection].location);
			msg = true;
		}
		else
		  fbfwca.Config.CONFIG_INIT = false; 

		if ( selection == 0 )
		{
			dijit.hideTooltip(obj.Remote_location.domNode);
			obj.Remote_location.promptMessage = null;
			obj.Remote_location.attr('required', false);
			obj.Remote_location.reset();
		}
		
		fbfwca.Config.setDisabledAttr(obj, remoteList[selection].disable, remoteList[selection].advanced);

		// override for WebDav: disable compression option
		if ( selection == 4 )
			obj.Remote_compressRB.attr('disabled', true);

		if ( remoteList[selection].disable == false)
		{
			if ( warningMsg )
			{
			  if ( msg )
				  fbfwca.Config.onRemote_locationChanged("FBWRemote_displayed");
			}
			else if (msg)
			{
				msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
						{message: NLS_MESSAGES.FBW1008I,
						 messageId: "FBW1008I",
						 type: "Info"});
				msgDlg.show();
			}
		}

	},

	/**************************************************************************
	* Issues a warning message when remote backup location was changed
	*
	* Parameter:
	*		cookie - cookie to check if msg has already been displayed once
	**************************************************************************/	
	onRemote_locationChanged : function (cookie)
	{
		var NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
		var displayed = dojo.cookie(cookie);
		if ( displayed == undefined )
		{
			dojo.cookie(cookie, "displayed");
			var msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
					{message: NLS_MESSAGES.FBW1012W,
					 messageId: "FBW1012W",
					 type: "Warning"});
			msgDlg.show();
		}
			
	},
	
	/**************************************************************************
	* Handles selection changes for Remote backup to filtering select
	*
	* Parameter:
	*		obj - notebook object or wizard object
	*		value - disable value
	*		advanced - disable value for advanced settings widgets
	**************************************************************************/	
	setDisabledAttr : function (obj, value, advanced)
	{
			obj.Remote_location.attr('disabled', value);
			obj.Remote_versionsKeep.attr('disabled', value);
			obj.Remote_maxspace.attr('disabled', value);
			obj.Remote_maxspace_unitFS.attr('disabled', value);

			// Advanced settings 
			obj.Remote_encryptRB.attr('disabled', advanced);
			obj.Remote_compressRB.attr('disabled', advanced);
			obj.Remote_subfileCK.attr('disabled', advanced);
			if (advanced == false && obj.Remote_subfileCK.attr('checked') == false )
			{
				obj.Remote_subfile.attr('disabled', true);
				obj.Remote_subfile_unitFS.attr('disabled', true);
			}
			else
			{
				obj.Remote_subfile.attr('disabled', advanced);
				obj.Remote_subfile_unitFS.attr('disabled', advanced);
			}

	},
	
	/**************************************************************************
	* Handles the encrypt backups radio button on the Remote page
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
 	onEncryptRBClicked : function (obj) 
	{
		if ( obj.encryptRBState )
		{
			obj.Remote_encryptRB.attr('checked', false);
			obj.encryptRBState = false;
		}
		else
		{
			obj.Remote_encryptRB.attr('checked', true);
			obj.encryptRBState = true;
		}
		
		obj.Remote_compressRB.attr('checked', false);
		obj.compressRBState = false;
	},

	/**************************************************************************
	* Handles compress backups radio button on the Remote page
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	onCompressRBClicked : function (obj) 
	{
		if ( obj.compressRBState )
		{
			obj.Remote_compressRB.attr('checked', false);
			obj.compressRBState = false;
		}
		else
		{
			obj.Remote_compressRB.attr('checked', true);
			obj.compressRBState = true;
		}

		obj.Remote_encryptRB.attr('checked', false);
		obj.encryptRBState = false;
		
	},

	/**************************************************************************
	* Handles subfile checkbox on the Remote page
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	onSubfileCKChanged : function (obj) 
	{
		if ( obj.Remote_subfileCK.attr('checked') == true )
		{
			obj.Remote_subfile.attr('disabled', false);
			obj.Remote_subfile_unitFS.attr('disabled', false);
		}
		else
		{
			obj.Remote_subfile.attr('disabled', true);
			obj.Remote_subfile_unitFS.attr('disabled', true);
		}
		
	},

	/**************************************************************************
	* Validates Continuous Protection page of the wizard or the notebook.
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/
	/*	
	validateContinuousPage : function (obj) 
	{
		var NLS = dojo.i18n.getLocalization("nls", "general");	
		var status = true;	
		var selection = obj.Continuous_protectLevelFS.attr('value');
		if ( selection == 1 || selection == 3 )
		{
			obj.Continuous_backupTo.attr('required', true);
			obj.Continuous_backupTo.promptMessage = NLS.T_REQUIRED_FIELD;
			if (!obj.Continuous_backupTo.validate(true))
				status = false;	
		}
		
		return status;
	},
	*/
	
	/**************************************************************************
	* Validates Continuous Protection page of the wizard or the notebook.
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	validateProtectionPage : function (obj) 
	{
		var status = true;	
		if ( obj.Protect_filesFolder.attr('value') == "" )
				status = false;	
		
		return status;
	},

	/**************************************************************************
	* Validates Remote Protection page of the wizard or the notebook.
	*
	* Parameter:
	*		obj - notebook object or wizard object
	**************************************************************************/	
	validateRemotePage : function (obj) 
	{
		var NLS = dojo.i18n.getLocalization("nls", "general");	
		var status = true;	
		var selection = obj.Remote_backupToFS.attr('value');
		if ( selection > 0 )
		{
			obj.Remote_location.attr('required', true);
			obj.Remote_location.promptMessage = NLS.T_REQUIRED_FIELD;
			if (!obj.Remote_location.validate(true))
				status = false;	
		}
		
		return status;
	},

	/**************************************************************************
	* Converts admin poll rate value in minutes to appropriate unit and return in
	* an object format:
	*    time.value = 2 (value of 2)
	*    time.unit = 0 (index for minutes)
	*
	* Parameter:
	*		value - storage value
	**************************************************************************/		
	ConvertPollRate: function (value) {
	    var multipliers = [7*24*60*1, 24*60*1, 60*1, 1];
			var suffixes = [3, 2, 1, 0];
			var val = parseInt(value, 10);
			var newValue = val;
			var suffix = 0;
	
	    for (i=0; i < multipliers.length; i++) {
	        if (val >= multipliers[i]) {
	            newValue = val / multipliers[i];
	            suffix = suffixes[i];
	            break;
	        }
	    }
    
	    var time = new Object();
	    time.value = Math.round(newValue);
	    time.unit = suffix;
		return time;
	},

	/**************************************************************************
	* Gets admin poll rate value in minutes.
	*
	* Parameter:
	*		value - settings value
	*		unit - settings value unit
	**************************************************************************/		
	GetPollRate: function (value, unit) {
	  var multipliers = [1, 60*1, 24*60*1, 7*24*60*1];
		return (value * multipliers[unit]);
	},
		
	/**************************************************************************
	* Converts the back-end's backup schedule target time to a more convenient 
	* schedule object.
	*
	* Parameters:
	*		targetBackupTime - scheduled backup's targetBackupTime from the back-end
	*		frequency        - schedule backup's frequency from the back-end
	* Returns:  
	*       Returns an object fields that vary based on the passed in frequency.
	*
	*       frequency: monthly
	*           dayOfMonth - zero based day of the month
	*           time       - number of seconds into the day to start the backup
	*       frequency: weekly
	*           dayOfWeek  - zero based day of the week
	*           time       - number of seconds into the day to start the backup
	*       frequency: daily
	*           time       - number of seconds into the day to start the backup
	**************************************************************************/
	targetBackupTimeToSchedule: function(targetBackupTime, frequency) {
		var SECONDS_PER_HOUR = (60 * 60);
		var SECONDS_PER_DAY = (60 * 60 * 24);
		var schedule = new Object();
		schedule.dayOfMonth = 0;
		schedule.dayOfWeek = 0;
		schedule.time = 0;

		if ( frequency == "disabled" )
			schedule.frequency = "none";
		else
			schedule.frequency = frequency;
		if (frequency == "monthly") {
		    schedule.dayOfMonth = Math.floor(targetBackupTime / SECONDS_PER_DAY);
		    schedule.time = targetBackupTime % SECONDS_PER_DAY;
		} else if (frequency == "weekly") {
		    schedule.dayOfWeek = Math.floor(targetBackupTime / SECONDS_PER_DAY);
		    schedule.time = targetBackupTime % SECONDS_PER_DAY;
		} else if (frequency == "daily") {
		    schedule.time = targetBackupTime % SECONDS_PER_DAY;
		} else {
		    //nothing to do
		}
		
		schedule.hour = Math.floor(schedule.time / SECONDS_PER_HOUR);
		schedule.minutes = Math.floor((schedule.time - (schedule.hour*SECONDS_PER_HOUR))/60);
			
		console.log("targetBackupTimeToSchedule: ", frequency, "  ", schedule);
		return schedule;
	},

	/**************************************************************************
	* Converts a schedule object to the back-end's backup schedule target time.
	*
	* Parameter:
	*		schedule - scheduled object, see targetBackupTimeToSchedule details
	*
	* Returns:  
	*       Returns a target backup time for back-end.
	*
	**************************************************************************/
	scheduleToTargetBackupTime: function(schedule) {
		var SECONDS_PER_DAY = (60 * 60 * 24);
		var targetBackupTime = 0;
		
		if (schedule.frequency == "monthly") {
		    targetBackupTime = schedule.dayOfMonth * SECONDS_PER_DAY;
		    targetBackupTime += schedule.time;
		} else if (schedule.frequency == "weekly") {
		    targetBackupTime = schedule.dayOfWeek * SECONDS_PER_DAY;
		    targetBackupTime += schedule.time;
		} else if (schedule.frequency == "daily") {
		    targetBackupTime = schedule.time;
		} else {
		    //nothing to do
		}
		console.log("scheduleToTargetBackupTime: ", schedule.frequency, "  ", targetBackupTime);
		return targetBackupTime;
	 },
  
	/**************************************************************************
	* Format a schedule object to a display text.
	*
	* Parameter:
	*		schedule - scheduled object, see targetBackupTimeToSchedule details
	*
	*       frequency: monthly
	*           dayOfMonth - actual display value in the filtering select
	*           hours      - 0-23 base hours
	*           minutes    - 0-59 base minutes
	*       frequency: weekly
	*           dayOfWeek  - actual display value in the filtering select
	*           hours      - 0-23 base hours
	*           minutes    - 0-59 base minutes
	*       frequency: daily
	*           hours      - 0-23 base hours
	*           minutes    - 0-59 base minutes
	* Returns:  
	*       formatted text to be displayed.
	*
	**************************************************************************/
	formatScheduleText: function(schedule) {
		var NLS = dojo.i18n.getLocalization("nls", "general");	
		var msg = "";
	
		if (schedule.frequency == "none" || schedule.frequency == "disabled")
			msg = NLS.T_Never;
		else
		{
			var time = schedule.hour + ":" + (schedule.minutes ? (""+schedule.minutes) : "00");
			if (schedule.frequency == "monthly") {
				msg = dojo.string.substitute(NLS.T_on_dayOfMonth_at_time, {0: schedule.dayOfMonth, 1: time});
			} else if (schedule.frequency == "weekly") {
				msg = dojo.string.substitute(NLS.T_on_dayOfWeek_at_time, {0: schedule.dayOfWeek, 1: time});
			} else if (schedule.frequency == "daily") {
				msg = dojo.string.substitute(NLS.T_daily_at, {0: time});
			} else if (schedule.frequency == "hourly") {
				msg = NLS.T_every_hour;
			}
		
			msg = dojo.string.substitute(NLS.T_Summary_emailProtection, { 0: msg });
		}
		
		return msg;
	},

	/**************************************************************************
	* Returns an index for the the remote backup to field.
	*
	* Parameter:
	*		target - location of backup
	*
	* Returns:  
	*       index value for the filteringselect widget
	*
	**************************************************************************/  
	getTargetType: function (target) {
		var result = 0; //asume we don't find a match
		if (target.charAt(1)==":") {
			result = 1;
		}
		else if (target.indexOf("\\\\")==0) {
			result = 2;
		}
		else if (target.indexOf("tsm")==0) {
			result = 3;
		}
		else if (target.indexOf("http")==0) {
			result = 4;
		}
		return result;
	},

	/**************************************************************************
	* Returns an index for the the remote backup to field.
	*
	* Parameter:
	*		target - location of backup
	*		nlsString - true to return NLS string, false to return selection value
	*
	* Returns:  
	*       index value for the filteringselect widget
	*
	**************************************************************************/  
	getEmailAppFromIncludes: function (includes, nlsString) {
		var NLS = dojo.i18n.getLocalization("nls", "general");	
		var emailAppList = [ 
			{app: "Select Application", includes: "", disable: true, nlsStr: NLS.T_None},
			{app: "Lotus Notes", includes: "*.id|*.nsf", disable: true, nlsStr: NLS.T_Lotus_Notes},
			{app: "Microsoft Outlook", includes: "*.pst", disable: true, nlsStr: NLS.T_MS_Outlook},
			{app: "Microsoft Outlook Express 5.5, 6", includes: "*.mbx|*.dbx", disable: true, nlsStr: NLS.T_MS_Outlook_Express},
			{app: "All", includes: "*.id|*.nsf|*.pst|*.mbx|*.dbx", disable: true, nlsStr: NLS.T_All},
			{app: "Other", includes: "*.id|*.nsf|*.pst|*.mbx|*.dbx", disable: false, nlsStr: NLS.T_Other}
		];
		
		var result = emailAppList.length-1; //assume we don't find a match
		for (i = 0; i < emailAppList.length-1; i++) {
			if (includes == emailAppList[i].includes) {
				result = i;
				break;
			}
		}
		
		if ( nlsString )
		{
			console.log("nlsstr=" + emailAppList[result].nlsStr);
			return emailAppList[result].nlsStr;
		}
		else
			return result;
	},

	/**************************************************************************
	* Returns true if value equals the subfile magic number.  Otherwise return
	* false.
	*
	* Parameter:
	*		value - subfile threshold value
	*
	* Returns:  
	*       true or false
	*
	**************************************************************************/  
	isThresholdValue: function (value) {
		var subFileMagic = 1099511627776;
		if ( value == subFileMagic )
			return true;
		else
			return false;
	}
	
};

}
