/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["fbfwca.Folders"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["fbfwca.Folders"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.DropDownButton");
dojo.require("dijit.Menu");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");		
dojo.require("fbfwca.Grid");
dojo.require("fbfwca.Alerts");
dojo.require("fbfwca.Scripts");
dojo.require("fbfwca.Common");
dojo.require("fbfwca.ajax");
dojo.requireLocalization("nls", "general", null, "");
dojo.requireLocalization("nls_messages", "messages", null, "");

dojo.provide("fbfwca.Folders");

dojo.declare("fbfwca.Folders", null, {

	/**************************************************************************
	* Constructor
	**************************************************************************/
	constructor : function() {
		console.log("fbfwca.Folders(): in constructor");
		this.mainPageId = 'MainTableHolder';
		this.EditFolderId = 'EditFolderForm';
		this.CreateConfigId = 'CreateConfigForm';
		this.connections = [];
		this.topics = [];
		this.gridObj = null;
		this.grid = null;
	  this.alerts = null;
	  this.scripts = null;
		this.NLS = dojo.i18n.getLocalization("nls", "general");
		this.NLS_MESSAGES = dojo.i18n.getLocalization("nls_messages", "messages");
  },

  /**************************************************************************
  * switch to folders sub page.
  **************************************************************************/
  initPage : function (Alerts, Scripts) {
		this.alerts = Alerts;
		this.scripts = Scripts;
		this.InitFoldersTable();
  },


	/**************************************************************************
	* Cleanup function
	**************************************************************************/
	destroy : function () {
	  	// Destroy all subscriptions
	  	dojo.forEach(this.topics, dojo.unsubscribe);
	  	delete this.topics;
	  	
	  	// Destroy all event connections
		dojo.forEach(this.connections, dojo.disconnect);
	  	delete this.connections;

		if (dijit.byId(this.mainPageId)) {
			console.log("destroy MainTableHolder");
			dijit.byId(this.mainPageId).destroyRecursive();
		}
		
		if (dijit.byId(this.EditFolderId)) {
			console.log("destroy EditFolderForm");
			dijit.byId(this.EditFolderId).destroyRecursive();
		}

		if (dijit.byId(this.CreateConfigId)) {
			console.log("destroy CreateConfigForm");
			dijit.byId(this.CreateConfigId).destroyRecursive();
		}
				
		delete this.mainPageId;
		delete this.EditFolderId;
		delete this.CreateConfigId;
		delete this.grid;
		delete this.gridObj;
		delete this.alerts;
		delete this.scripts;
		delete this.NLS;
		delete this.NLS_MESSAGES;

 	},

	/**************************************************************************
	* Creates & loads the admin folders table.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	InitFoldersTable : function () {

    var textAlign;
    if(dojo.getComputedStyle(dojo.body()).direction == "rtl")
      textAlign = "text-align:right;";
    else
      textAlign = "text-align:left;";
	      
		// Create the layout
		var layout = [
			{field: "_checked", name: "&nbsp;", width:"28px", editable:true, type:dojox.grid.cells.Bool,
				filter:false, styles: "text-align: center;" },
			{field: 'status', name: this.NLS.T_Connection_Status, width:'80px',
				filter:false, formatter:fbfwca.Formatters.ConnectStatusFormatter, styles:"text-align: center;" },
			{field: 'name', name: this.NLS.T_Alias, width:'20%', cellClasses: "fauxLink", filter:true, styles:textAlign },
			{field: 'group', name: this.NLS.T_Group, width:'15%', filter:true, styles:textAlign },
			{field: 'script', name: this.NLS.T_Initial_Script, width:'15%', filter:true, styles:textAlign },
			{field: 'clients', name: this.NLS.T_Number_of_Clients, width:'10%', filter:true,
				styles: "text-align:center;"},
			{field: 'address', name: this.NLS.T_Administration_Folder, width:'40%', filter:true,
				formatter:fbfwca.Formatters.PathFormatter, styles:textAlign }
		];

		// Create toolbar widgets
		var	createButton = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.NLS.T_IDENTIFY_FOLDER,
					showLabel: false, 
					iconClass: "newIcon" 
				});
		this.connections.push (dojo.connect(createButton, 'onClick', dojo.hitch(this, this.PerformAction, "create")));

    var	deleteButton = new ibm.tivoli.tip.dijit.TIPButton(
		{	label: this.NLS.T_DELETE_FOLDER,
			showLabel: false, 
			iconClass: "deleteIcon"
		});
		this.connections.push (dojo.connect(deleteButton, 'onClick', dojo.hitch(this, this.DeleteAdminFolder)));

    // --------------- create menu -------------------
    var menu = new dijit.Menu();
    var item = null;
    menu.addChild(
        item = new dijit.MenuItem({
            iconClass: "newIcon",
            label: this.NLS.T_IDENTIFY_FOLDER,
            title: this.NLS.T_IDENTIFY_FOLDER,
            id: "CreateFolderID"
        })
    );
    this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "create")));

    menu.addChild(
        item = new dijit.MenuItem({
            label: this.NLS.T_MODIFY_FOLDER,
            title: this.NLS.T_MODIFY_FOLDER,
            iconClass: "editIcon",
            id: "ModifyFolderID",
            disabled: true
        })
    );
    this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "modify")));
    menu.addChild(
        item = new dijit.MenuItem({
        		label: this.NLS.T_DELETE_FOLDER,
        		title: this.NLS.T_DELETE_FOLDER,
		    iconClass: "deleteIcon",
		    id: "DeleteFolderID",
		    disabled: true
        })
    );
    this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.DeleteAdminFolder)));

    menu.addChild(
        item = new dijit.MenuItem({
            label: this.NLS.T_Create_Config_File,
            title: this.NLS.T_Create_Config_File,
            iconClass: "templateIcon",
		    id: "CreateConfigID",
		    disabled: true
        })
    );
    this.connections.push (dojo.connect(item, 'onClick', dojo.hitch(this, this.PerformAction, "createconfig")));
    menu.startup();
		this.connections.push (dojo.connect(menu, 'onOpen', dojo.hitch(this, this.OnClick_TableAction)));
                
		var actionsDropDown = new dijit.form.DropDownButton({
	         label: this.NLS.T_ACTIONS,
	         title: this.NLS.T_ACTIONS,
	         dropDown: menu
		});
    // Create the grid
    var gridParms = { storeURL : "admin_folders",
                        layout : layout,
                        query : {address:"*"},
                        //refreshButton : false,
                        filterOn : false,
                        createButton : createButton,
                        deleteButton : deleteButton,
                        actionsDropDown : actionsDropDown
                    };

    this.gridObj = new fbfwca.Grid(gridParms, document.createElement('div'));
    dojo.byId("foldersGridContainerNode").appendChild(this.gridObj.domNode);
    this.gridObj.resize();
    this.grid = this.gridObj.getTable();

		// Connect table default action
		this.connections.push (dojo.connect(this.grid, 'onCellClick', dojo.hitch(this, this.LaunchTableDefaultAction)));
		this.connections.push (dojo.connect(this.grid, "onCellMouseOver", this.ShowGridTooltip));
		this.connections.push (dojo.connect(this.grid, "onCellMouseOut", this.HideGridTooltip));				        
	},

	/**************************************************************************
	* Resize table object
	**************************************************************************/		
	ResizeTable : function (){
		if (this.gridObj)
			this.gridObj.resize();
	},
	
	/**************************************************************************
	* Hide tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	HideGridTooltip : function (e){
		dijit.hideTooltip(e.cellNode);
		dijit._masterTT._onDeck=null;
	},

	/**************************************************************************
	* Shows tooltip
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	ShowGridTooltip : function (e) {
		var row;
		if (e.grid.getCell(e.cellIndex).field == "address")
		{
			row = e.grid.getItem(e.rowIndex);
			dijit.showTooltip(e.grid.store.getValue(row, "address", "0"), e.cellNode);
		}
	},
	
	/**************************************************************************
	* Handles default table action.
	*
	* Parameter:
	*		e - event
	**************************************************************************/		
	LaunchTableDefaultAction : function (e) {
		if (e.grid.getCell(e.cellIndex).field == "name")
		{
			this.PerformAction('modify');
			e.grid.selection.deselect(e.rowIndex);
		}
	},

	/**************************************************************************
	* Handles table action.
	*
	* Parameter:
	*		action - which action
	**************************************************************************/		
	PerformAction : function (action){
		if (action == 'create' )
			this.ShowAdminFolderForm('create');
		else if (action == 'modify' )
			this.ShowAdminFolderForm('modify');
		else if (action == 'createconfig' )
			this.ShowCreateConfig();
		else
			alert("Invalid action");
	},

	/**************************************************************************
	* Initializes and shows the Edit Admin Folder form.
	*
	* Parameter:
	*		action - which action
	**************************************************************************/		
	ShowAdminFolderForm : function (action) {

		dijit.byId("FolderOKBtn").attr("label", this.NLS.T_OK);
		dijit.byId("FolderAnotherBtn").attr("label", this.NLS.T_ADD_ANOTHER);
		dijit.byId("FolderCancelBtn").attr("label", this.NLS.T_CANCEL);
		dijit.byId("FolderOKBtn2").attr("label", this.NLS.T_OK);
		dijit.byId("FolderCancelBtn2").attr("label", this.NLS.T_CANCEL);

		dijit.byId("FolderOKBtn").attr("title", this.NLS.T_OK);
		dijit.byId("FolderAnotherBtn").attr("title", this.NLS.T_ADD_ANOTHER);
		dijit.byId("FolderCancelBtn").attr("title", this.NLS.T_CANCEL);
		dijit.byId("FolderOKBtn2").attr("title", this.NLS.T_OK);
		dijit.byId("FolderCancelBtn2").attr("title", this.NLS.T_CANCEL);
				
		var div1 = document.getElementById("EditFolderFormHead");
		var div2 = document.getElementById("EditFolderFormDesc");
		
		var name = dijit.byId('EditFolder_name');
		var address = dijit.byId('EditFolder_address');
		var groupsFS = dijit.byId('EditFolder_groupsFS');
		var scriptsFS = dijit.byId('EditFolder_scriptsFS');
		
		name.promptMessage = this.NLS.T_REQUIRED_FIELD;
		address.promptMessage = this.NLS.T_REQUIRED_FIELD;
		
		groupsFS.store = fbfwca.ajax.getGroupSelectionList();
		scriptsFS.store = fbfwca.ajax.getScriptsSelectionList();
		
		if (action == "create")
		{
			div1.innerHTML = this.NLS.T_IDENTIFY_FOLDER;
			div2.innerHTML = this.NLS.T_Identify_Admin_Folder_Desc;
  		dojo.style('EditFolder_ThreeButtons', 'display', 'block');
  		dojo.style('EditFolder_TwoButtons', 'display', 'none');
			name.attr('disabled', false);
			address.attr('disabled', false);
			this.ResetForm();
			//dojo.byId('EditFolder_name').focus();
		}
		else
		{
			div1.innerHTML = this.NLS.T_MODIFY_FOLDER;
			div2.innerHTML = this.NLS.T_Modify_Admin_Folder_Desc;
  		dojo.style('EditFolder_TwoButtons', 'display', 'block');
  		dojo.style('EditFolder_ThreeButtons', 'display', 'none');
			name.attr('disabled', true);
			address.attr('disabled', true);
			//dojo.byId('EditFolder_groupsFS').focus();

			var item = this.grid.selection.getFirstSelected();
			name.attr('value', this.grid.store.getValue(item, "name"));
			address.attr('value', this.grid.store.getValue(item, "address"));
			if (this.grid.store.getValue(item, "group") === "" )
				groupsFS.attr('value', this.NLS.T_None);
			else
				groupsFS.attr('value', this.grid.store.getValue(item, "group"));
			
			if (this.grid.store.getValue(item, "script") === "" )
				scriptsFS.attr('value', this.NLS.T_None);
			else
				scriptsFS.attr('value', this.grid.store.getValue(item, "script"));
		}
		fbfwca.Common.ShowForm(this.EditFolderId, this.mainPageId);
	},

	/**************************************************************************
	* Resets widgets on the Edit Admin Folder form.
	* Mainly to initialize fields to default value.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ResetForm : function (){
		dijit.byId('EditFolder_name').attr('value',"");
		dijit.byId('EditFolder_address').attr('value',"");
		dijit.byId('EditFolder_groupsFS').attr('value', this.NLS.T_None);
		dijit.byId('EditFolder_scriptsFS').attr('value', this.NLS.T_None);
	},

	/**************************************************************************
	* Issues a confirm message for the deletion.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	DeleteAdminFolder : function () {
		var msgDlg;
		if ( this.grid.selection.getSelectedCount() == 0 )
		{
			msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
					{message: this.NLS_MESSAGES.FBW1002E,
					 messageId: "FBW1002E",
					 type: "Error"});
		}
		else
		{
			var buttons = [this.NLS.T_OK, this.NLS.T_CANCEL];
			msgDlg = new ibm.tivoli.tip.dijit.TIPMessageDialog(
					{message: this.NLS_MESSAGES.FBW1001C,
					 messageId: "FBW1001C",
					 type: "Confirm",
					 callback: this.DeleteFolderCallback,
					 callbackParms: {grid: this.grid, gridObj: this.gridObj},
					 buttons: buttons});
		}
		msgDlg.show();
	},

	/**************************************************************************
	* Delete call back.  Called by TIPMessageDialog.
	*
	* Parameter:
	*		buttonPressedId - button pressed
	*		messageId - message ID
	*		checked - show checked box check
	*		parms - {grid: this.grid, gridObj: this.gridObj}
	**************************************************************************/		
	DeleteFolderCallback : function (buttonPressedId, messageId, checked, parms) {

		if (buttonPressedId == 0)
		{
		  var count = 0;
	    parms.grid.store.fetch(
		  {
			  query: {_checked:true},
			  onItem: function(item, request) {
					  console.log("DeleteFolderCallback: " + item.address);
					  fbfwca.ajax.deleteAdminFolder(item.address);
					  parms.grid.store.deleteItem(item);
					  count++;
			  }
		  });
		  parms.grid.store.save();
		  parms.grid.sort();
		  parms.gridObj.updateFooter(parms.grid.rowCount-count, 0);
		}
	},

	/**************************************************************************
	* Initializes and shows the Create Configuration form.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	ShowCreateConfig : function () {
		dijit.byId("CreateConfigFormGetConfig").attr("label", this.NLS.T_Get_Configuration);
		dijit.byId("CreateConfigFormReturn").attr("label", this.NLS.T_RETURN);
		
		dijit.byId("CreateConfigFormGetConfig").attr("title", this.NLS.T_Get_Configuration);
		dijit.byId("CreateConfigFormReturn").attr("title", this.NLS.T_RETURN);
		
		var item = this.grid.selection.getFirstSelected();
		document.getElementById("CreateConfig_groupId").innerHTML = this.grid.store.getValue(item, "group");
		document.getElementById("CreateConfig_adminfolderId").innerHTML = this.grid.store.getValue(item, "address");
		dijit.byId('CreateConfig_xml').attr("value", "");
	    
		fbfwca.Common.ShowForm(this.CreateConfigId, this.mainPageId);
	},

	/**************************************************************************
	* Calls backend to get configuration and paste it to the text area.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	GetConfig : function () {
    	var response = fbfwca.ajax.generateConfigFile(document.getElementById("CreateConfig_adminfolderId").innerHTML);
		if ( response == -1 )
			return;
        var s = unescape(response.xml);
        s = s.replace(/\\u000A/g, "\n");
        dijit.byId('CreateConfig_xml').attr('value', s);
	},
	
	/**************************************************************************
	* Handles buttons on Edit Admin Folder form.
	*
	* Parameter:
	*		buttonId - which button was pressed (0=OK, 1=Add Another, 2=Cancel)
	**************************************************************************/		
	OnClick_EditFolder : function (buttonId) {
    
		// Cancel button
		if ( buttonId == 2 )
		{
			this.CleanupForm();
			fbfwca.Common.HideForm(this.EditFolderId, this.mainPageId);
   		this.RefreshTables();
			return;
		}
		
		// OK or add another button
		var name = dijit.byId('EditFolder_name');
		var address = dijit.byId('EditFolder_address');
		var groupsFS = dijit.byId('EditFolder_groupsFS');
		var scriptsFS = dijit.byId('EditFolder_scriptsFS');

		if (name.attr('disabled') == false &&
			(!name.validate(true) || !address.validate(true) ) )
			return;
		
		if (!groupsFS.validate(true) || !scriptsFS.validate(true))
			return;
				
		// Create action 
		var response;
		var group = groupsFS.attr('value');
		if ( group == this.NLS.T_None )
			group = "";
		
		var script = scriptsFS.attr('value');
		if ( script == this.NLS.T_None )
			script = "";
					
		if (name.attr('disabled') == false )
			response = fbfwca.ajax.addAdminFolder(name.attr('value'), address.attr('value'), group, script);
		else
			response = fbfwca.ajax.modifyAdminFolder(name.attr('value'), address.attr('value'), group, script);
	
		if ( response == -1 )
			return;
					
		if (buttonId == 1)
		{
			this.CleanupForm();
			this.ResetForm();
		}
		else
		{
			this.CleanupForm();
			fbfwca.Common.HideForm(this.EditFolderId, this.mainPageId);
			this.RefreshTables();
		}
	},

	RefreshTables : function () 
	{
		this.gridObj.onRefresh();
		this.alerts.gridObj.onRefresh();
		this.scripts.gridObj.onRefresh();
	},
	      		
	/**************************************************************************
	* Handles the browse button.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_Browse : function () {
        
	    var  dialogId = dijit.byId("folderSelectionDialog");
        dialogId.titleNode.innerHTML = this.NLS.T_Folder_Select;

        console.log("show dialog with id: "+ dialogId);
        dialogId.show();       

        this.Tree = new dijit.Tree();
        console.log("tree created");
        dojo.byId("folderTreeContainer").appendChild(this.Tree.domNode);
                
	},

    /**************************************************************************
    * Handles  buttons pressed on folder selection panel.
    *
    * Parameter:
    *		buttonId - which button was pressed (0=OK, 1=Cancel)
    **************************************************************************/		
    OnClick_FolderSelectForm : function (buttonId) {
        // OK button
        if (buttonId == 0)
        {
            dijit.byId("CreateConfig_name").attr('value', "test");
        }
  	
        if (this.AddrGridObj){
            this.AddrGridObj.destroy();
        }

        dijit.byId("folderSelectionDialog").hide();
        return;
    },

	/**************************************************************************
	* Handles button pressed on Create Configuration form.
	*
	* Parameter:
	*		buttonId - which button was pressed (0=OK, 1=Cancel)
	**************************************************************************/		
	OnClick_CreateConfig : function () {

		fbfwca.Common.HideForm(this.CreateConfigId, this.mainPageId);
		this.RefreshTables();
		return;
	},

	/**************************************************************************
	* Enables or disables actions based on user's action selection.
	*
	* Parameter:
	*		none
	**************************************************************************/		
	OnClick_TableAction : function () {
		var nodes = this.grid.selection.getSelected();
		
		var DeleteAction = dijit.byId("DeleteFolderID");
		var ModifyAction = dijit.byId("ModifyFolderID");
		var GetAction = dijit.byId("CreateConfigID");

		if ( nodes.length == 0 )
		{
			DeleteAction.attr('disabled', true);
			ModifyAction.attr('disabled', true);
			GetAction.attr('disabled', true);
		}
		else if ( nodes.length == 1 )
		{
			DeleteAction.attr('disabled', false);
			ModifyAction.attr('disabled', false);

			var group = this.grid.store.getValue(nodes[0], "group");

			if (group == "" )
				GetAction.attr('disabled', true);
			else
				GetAction.attr('disabled', false);
		}
		else
		{
			DeleteAction.attr('disabled', false);
			ModifyAction.attr('disabled', true);
			GetAction.attr('disabled', true);
		}
	},

	/**************************************************************************
	* Performs cleanup.
	* Important to reset any required widgets & hide tooltip
	*
	* Parameter:
	*		none
	**************************************************************************/		
	CleanupForm : function () {
		var widgets = ['EditFolder_name', 'EditFolder_address', 
						'EditFolder_groupsFS', 'EditFolder_scriptsFS'];

		for (i=0; i < widgets.length; i++) {
			var widget = dijit.byId(widgets[i]);
			if (widget.attr('disabled') == false)
			{
				dijit.hideTooltip(widget.domNode);
				widget.reset();
			}
		}
	}
	
});

}
