/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTable"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007, 2010 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojox.data.QueryReadStore");
dojo.require("ibm.tivoli.tip.dojo.TIPQueryReadStore");
dojo.require("ibm.tivoli.tip.dijit.TIPDataGrid");

dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane" );

dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");
//dojo.require("ibm.tivoli.tip.dijit.TIPTableTitleBar");
dojo.require("ibm.tivoli.tip.dijit.TIPTableToolbar");
dojo.require("ibm.tivoli.tip.dijit.TIPTableFooter");
dojo.require("ibm.tivoli.tip.dijit.TIPTableRefreshButton");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.dijit.TIPTableSearchField");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenu");
dojo.require("ibm.tivoli.tip.dijit.TIPTableOptionsDialog");
dojo.require("dijit.form.FilteringSelect");
dojo.require ("ibm.tivoli.tip.charts.dojo.RESTErrorHandler");
dojo.require("dojo.parser");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw", "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw");

dojo.provide("ibm.tivoli.tip.dijit.TIPTable");

/******************************************************************************
* This container places the search bar and toolbar around a given 
* dojox.grid.Grid 
*
* Authors: Joseph Firebaugh, Joshua Allen, Ken Parzygnat
******************************************************************************/
dojo.declare("ibm.tivoli.tip.dijit.TIPTable",
			 dijit.layout.BorderContainer,
{
	grid: null,
	gridParms: null,
	global: null,
	requestTimeout: 30000,
	defaultRowsPerPage: 25,
	tableID: null,
	autoSavePreferences : false,
	toolbarHidden_ : false,
	/* Do you want the default buttons added to the toolbar? */
	makeDefaultButtons: true,
	
	/* Table Options is the ability to hide/show columns.  
	   Preferences are handled via the infrastructure, however
	   they must persisted by the implementing application. 
	   Hence, the table options are disabled by default.  */
	tableOptionsEnabled: false,	
	multiSelect: true,
	rowDblClick: null,
	
	// open: Boolean
	//    Whether toolbar is opened or closed on first render.
	open: true,
    shownub : true, // for showing toolbar nub
	nubhover :false, // for hovering the toolbar nub
	// duration: Integer
	//    Time in milliseconds to wipe in/wipe out toolbar
	duration: 300,
	
	_contextMenu: null,
   	_onRowContextMenuListener: null,
   	_contextMenuAdapter : null,
	cmProvider: null,
	clientRfcItems : null,      // Provide if you are providing above view structure.
	view: null,
	viewData: null,
	applicationID: null,
	widgetID: null,
	tableParams: null,
	
	/*contentIsolation: boolean variable to enable/disable Context Menu in Content Isolation mode*/
	contentIsolation: false,

	constructor: function () {
		this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");	
		this.lastPreferences = null;
		this.viewLoaded = false;
		this.tooltips = [];
		this.connections = [];
		this.topics = [];
		this.tableOptionsDialog = null;
		this.originalStructure = null;
		this.toolbar = null;
		this.footerToolbar = null;
		this.filterBar = null;
	},
	
	/**************************************************************************
	* Called after template has been processed.
	*
	* Lets check to see if a dojox.grid.Grid was passed in on params.  If so,
	* add it to the DOM tree and setup.
	**************************************************************************/
	postCreate: function ()	{
		//call super
		this.inherited( "postCreate", arguments );
		
		this.domNode.style.padding = "0px";

		//console.log ("global: " + this.global);
		this.gridParms = this.initializeGridParameters();
		
		this.cPane1 = new dijit.layout.ContentPane( { region: "top" } );
      	this.addChild( this.cPane1 );
              
      	var div = dojo.doc.createElement( 'div' );
      	this.cPane1.attr( "content", div );
		
  
      //-----------------------------
      // Add Toolbar and filter area
      //-----------------------------
      	if(!this.tableBuilder || !this.tableBuilder.widgetParams || !this.tableBuilder.widgetParams.standalone ||(this.tableBuilder.widgetParams.standalone && !this.tableBuilder.widgetParams.ignoreToolbar)){
      		this.filterBar = new ibm.tivoli.tip.dijit.TIPTableToolbar( {shownub:this.shownub,nubhover:this.nubhover}, div );
            this.toolbar = this.filterBar.toolbar;      
            this.searchField = this.filterBar.searchField;
            if ( this.makeDefaultButtons === true ) { 
       	    	this.initializeToolbar(); 
            }             
            this.topics.push (dojo.subscribe (this.searchField.id + "searchInvoked", this, "onSearch"));
      	}      
		
		//-----------------------------
      	// Create Grid Pane            
      	//-----------------------------    
	   this.gridPane = new dijit.layout.ContentPane( { region: "center" } );
	   this.gridPane.style.margin="0px";
          
     	this.addChild( this.gridPane );
      
      	this.gridDiv = dojo.doc.createElement( 'div' );
      	dojo.addClass (this.gridDiv, "grid");
      	this.gridPane.attr( "content", this.gridDiv );      

//        this.connections.push (dojo.connect( this.gridPane, "resize", this, "resizeGrid"  ));
      
      //-----------------------------
      // Create and add footer            
      //-----------------------------    
      this.cPane2 = new dijit.layout.ContentPane( { region: "bottom" } );
      this.addChild( this.cPane2 );
  
      div   = dojo.doc.createElement( 'div' );
      this.cPane2.attr( "content", div );
  
      this.footerToolbar = new ibm.tivoli.tip.dijit.TIPTableFooter( {}, div );
      //console.log ("made footer: ");
      //console.log (this.footerToolbar);        
      
      
            		
      //if grid passed on params then set it
      if ( this.grid !== null )
      {
      	this.setGrid( this.grid );
      }
       
	  this.topics.push (dojo.subscribe ("/ibm.tip/TIPQueryReadStore#rowCountUpdated", this, "updateFooter"));
	},
	initializeGridParameters: function () {
		if (this.gridParms === null) {
			this.gridParms = {};
		}
		
		if (this.gridParms.store === undefined) {
			this.gridParms.store = new ibm.tivoli.tip.dojo.TIPQueryReadStore (
				{ global: this.global, tableID: this.tableID, jsId: "jsonStore", doClientPaging:false, 
				  url:this.global.controllerURL,
				  requestTimeout: this.requestTimeout 
				});
		} else {
			console.info ("this.gridParms.store is already defined");
			console.log (this.gridParms.store);
		}
			
		if (this.multiSelect) {
		} else {
			this.gridParms.selectionMode = "single";
		}
//		this.gridParms.query="{ name: '*' }";
		if (this.gridParms.rowsPerPage === undefined) {
			this.gridParms.rowsPerPage=this.defaultRowsPerPage;
		}
		if (this.gridParms.rowSelector === undefined) {
			this.gridParms.rowSelector = "20px";
		}
		//change value of this.gridParms.columnReordering to true on 2009/07/09 for column reordering
		if (this.gridParms.columnReordering === undefined) {
			this.gridParms.columnReordering = true;
		}
		
		var cb = dojo.hitch(this,function(){  
			console.debug("----- Inside the load complete callback ----");
			dojo.publish (this.id + "#LoadComplete", [ "LoadComplete" ]);
        });
        this.gridParms.loadCompleteCallback = cb;
		
//		this.gridParms.autoHeight = "false";

		return (this.gridParms);
	},
	startup: function() {
		console.info ("enter TIPTable.startup");
		if (!this.grid) {
			this.makeGrid();
		}

		if (this.autoSavePreferences && (!this.tableBuilder || (!this.tableBuilder.widgetParams || !this.tableBuilder.widgetParams.standalone))) {
			this.connections.push (dojo.connect (this.grid, "_resize", this, "onResize"));
			//console.log ("connected tiptable resize event");
		}
		
		this.connections.push (dojo.connect (this.grid, "onRowClick", this, "onRowClick"));
		this.connections.push (dojo.connect (this.grid, "onMoveColumn", this, "saveDOJOPreferences"));
		if(this.tableBuilder && (!this.tableBuilder.widgetParams || !this.tableBuilder.widgetParams.standalone)){
			this.connections.push (dojo.connect (this.grid, "prerender", this, "savePagePref"));
		}
		if(this.filterBar){
			this.connections.push (dojo.connect (this.filterBar.nub, "onclick", this, "toggleToolbar"));
		}
		console.info ("exit TIPTable.startup");
	},
	
	parseDataGrid: function(){		
		dojo.parser.parse(this.grid.domNode);		
    },
	
	makeGrid: function () {
		console.log ("enter makeGrid");
		var grid = new ibm.tivoli.tip.dijit.TIPDataGrid (this.gridParms, this.gridDiv);
		this.setGrid( grid , true );
		dojo.connect(grid,"_resize",this,"parseDataGrid");
		dojo.connect(grid,"onFetchError",this,dojo.hitch (this, function (error) {										
			var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(this.global);		
			errHandler.showError(dojo.fromJson(error.responseText));	
		}));
		grid.startup();

		if (this.widgetID !== null) {
		// TODO: We still need to set the widgetID a different way
//			this.query = {};
//			this.query.widgetID = this.widgetID;
//			this.query.applicationID = this.applicationID;
//			this.grid.setQuery (this.query);
			this.query = {
	                navModel: {	                        
	            		itemTypes: ['item'],
	            		parameters: {
							widgetID: this.widgetID
						}
					}
			};
			if(this.tableParams != null){
				for (var row in this.tableParams) {
					if (row) {
					 var param = this.tableParams[row];
					 this.query.navModel.parameters[param.id] = param.value;						
					}
				}
			}
			console.log("Params passed to table");
			console.log(this.query);
			this.grid.setQuery (this.query);
		}
		
		if ((this.view === undefined) || (this.view === null)) {
			console.log ("in TIPTable.makeGrid.  this.view is null so fetching from server");
			this.getView();
		} else {
			console.log ("in TIPTable.makeGrid.  this.view is already defined so using it:");
			this.originalStructure = this.viewData;
			console.log (this.originalStructure);
			this.setupView(this.view, this.viewData);
		}
		
		console.log ("exit makeGrid");
	},
	setGrid: function( grid ) {
		this.grid = grid;
		if(this.tableBuilder && this.searchBuild){			
			this.searchField.setTable( this.grid, this.tableBuilder.widgetDefinition );
		}else if(this.searchBuild){
			this.searchField.setTable( grid );
		}		
	},
	getView: function () {
        var kw = {
                    content:   {
                                  command: "getTableColumns",
                                  arg_fqTableId: this.tableID,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.getViewCallback)
                               }
                 };
	  	
	  	if (this.tableArgs) {
	  		for (var key in this.tableArgs) {
	  			if (key) {
		            kw.content[key] = this.tableArgs[key];
	  			}	
	  		}
	  	}
	  	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );
	},
	getViewCallback: function (data, ioArgs) {
		this.originalStructure = data;
		var cell = null;
		var cells = [];
		
  		var view1 = { cells: [ data.cells ] };
		// a grid layout is an array of views.
		var layout = [ view1 ];
		this.setupView (layout, data);
	},
	setupView: function (structure, data) {
		console.log ("enter setupView");
//		this.grid.attr('structure', structure);
		this.grid.attr( "structure", structure );
		var cell = null;
		for (var i in data.cells) {
			if (i) {
				cell = data.cells[i];
				if (cell.hidden) {
					this.grid.layout.setColumnVisibility(i, false);
				}
			}
		}
		if(this.tableBuilder && this.searchField){			
			this.searchField.setTable( this.grid, this.tableBuilder.widgetDefinition );
		}else if(this.searchField){
			this.searchField.setTable( this.grid );
		}		
 	    this.afterViewLoad(data.rcfItems);
	},
	afterViewLoad: function (rcfItems) {
		console.log ("Enter TIPTable.afterViewLoad");
		if (this.cmProvider) {
			this.configureContextMenu(rcfItems);  			
	  	}
	  		  	
	  	this.viewLoaded = true;
	},
	configureContextMenu: function (rcfItems) {
		if ((this.cmProvider.parentid === null) || (this.cmProvider.parentid === "")) {
			if ((this.tableBuilder !== undefined) && (this.tableBuilder != null)) {
				this.cmProvider.setParentId (this.tableBuilder.id);
			} else {
				this.cmProvider.setParentId (this.id);
			}
		}
		if ((this.cmProvider.rcfItems === null) && (rcfItems)) {
			this.cmProvider.rcfItems = rcfItems;
		}
		if(!this.tableBuilder || (this.tableBuilder && (!this.tableBuilder.widgetParams || !this.tableBuilder.widgetParams.standalone ||(this.tableBuilder.widgetParams.standalone && !this.tableBuilder.widgetParams.ignoreContextMenu)))){
			this._onRowContextMenuListener = dojo.connect( this.grid, "onRowContextMenu", this, "_onRowContextMenu" );
		}
      	 //FIXES CONTEXT MENU BUG with selected table rows IN DOJO 1.0.2
		 this.grid.focus.styleRow = function(inRow){};
      
	},
    getContextMenuAdapter: function()
    {
      if (this._contextMenuAdapter === null) {
         // Create the contextMenuAdapter.
         this._contextMenuAdapter = new ibm.tivoli.tip.dijit.TIPContextMenu({cmProvider: this.cmProvider, cmClientProvider: this.cmClientProvider});
      }
      return this._contextMenuAdapter;
    },
    /************************************************************************
    * This method is called each time a context menu is requred on a row
    ************************************************************************/
    _onRowContextMenu: function( e )
    { 
//    	console.log ("enter onrowcontextmenu");
      var row = e.grid.getItem( e.rowIndex );
      
      console.log ("row is: " + row);
      console.log ("e.rowIndex: " + e.rowIndex);
//      console.log ("grid: ");
//      console.log (e.grid);
      if ( row )
      {
        //select the row that the context menu was initiated on
        e.grid.selection.deselectAll( e.rowIndex );
        e.grid.selection.setSelected( e.rowIndex, true );
                
        //tell the context menu adapter to show the menu
        // no context is provided because we overload the _loadMenuItems method
//        var selection = this.getSelectionDataV2();
//        console.log ("selection data v2: ");
//        console.log (selection);
        var selection = this.getSelectionData();
        console.log ("selection data v1: ");
        console.log (selection);
        if(this.tableBuilder){
        	this.getContextMenuAdapter().contextMenuOpen( e, this.getDOJOTableSelectedDataV2(), this.contentIsolation);
        }else{
        	this.getContextMenuAdapter().contextMenuOpen( e, selection, this.contentIsolation );
        }        
      }
    },
	getSelectedRows: function () {
		return this.grid.selection.getSelected();
	},
	getAllColumnIndexes: function () {
//		console.log ("enter getAllColumnIndexes");
//		var count = this.grid.attr ('structure')[0].cells.length;
//		var count = this.grid.structure[0].cells.length;
		var count = this.originalStructure.cells.length;
		var columnIDs = [];
		for (var i=0; i<count; i++) {
			columnIDs.push (i);
		}
		
		return (columnIDs);
	},
	getValueAt: function (rowIndex, columnIndex) {
		var row = rowIndex.i;
//		console.log ("row: ");
//		console.log (row);
		if(row === undefined){
		row = rowIndex;
		}
		var value = row[columnIndex];
//		console.log ("value at row: " + rowIndex + ", column: " + columnIndex + " is: " + value);
		return (value); 
	},
	getModelData: function () {
		var selectedRows = this.getSelectedRows ();
		var row = selectedRows[0];
		var columnIDs = this.getAllColumnIndexes();

		for (var column in columnIDs) {
			if (column) {
				var data = this.getValueAt (row, column);
				//console.log ("cell value for row: " + row + ", and column: " + column + " : " + data);
			}
		}
	},
	getIdentifier: function () {
		return (this.originalStructure.cells.length);
	},
	
	getDOJOTableSelectedDataV2: function () {		
		var contextData = {};
		contextData.rcfs = [];
		var colNames = this.tableBuilder.widgetDefinition.datasets[0].columns;
		var datasourceType = this.tableBuilder.widgetDefinition.datasource.type;
		var datasourceId = this.tableBuilder.datasourceID;		
		var datasetId = this.tableBuilder.widgetDefinition.datasets[0].id;
		var rowIndex = null;
		var sourceToken = null;
		var selectedRows = this.getSelectedRows();
		dojo.forEach (selectedRows,	function (row) {				
			var resourceAttrs = [];							
			for(var i=0; i<colNames.length; i++){
				var attr = {};
				attr.name = colNames[i].label.key;								
				attr.value = this.tableBuilder.jsonStore.getValue (row, colNames[i].id);		
				attr.isNamingAttribute = false;
				resourceAttrs.push(attr);
			}			
			rowIndex = row.id;
			sourceToken = this.tableBuilder.jsonStore.getValue (row, ""+colNames.length);
			var attr = {};
			attr.name = "Class";
			attr.value = "*";
			attr.isNamingAttribute = false;
			resourceAttrs.push(attr);
			contextData.rcfs.push (resourceAttrs);
			
		}, this);		
		
		contextData.launchTypes = ["WEB_URL", "PORTAL_PAGE", "PORTLET", "CLIENT_EVENT"];
		contextData.excludedAppIDs = [];
		contextData.substitutionVariables = [];		
		var attr = {};
		attr.name = "RowIndex";
		attr.value = rowIndex;		
		contextData.substitutionVariables.push(attr);
		
		var attr = {};
		attr.name = "SourceToken";
		attr.value = sourceToken;
		if(attr.value!==undefined && attr.value!==null){
			contextData.substitutionVariables.push(attr);
		}
		
		var attr = {};
		attr.name = "DatasourceType";
		attr.value = datasourceType;	
		contextData.substitutionVariables.push(attr);
		
		var attr = {};
		attr.name = "DatasourceId";
		attr.value = datasourceId;	
		contextData.substitutionVariables.push(attr);	
		
		var attr = {};
		attr.name = "DatasetId";
		attr.value = datasetId;	
		contextData.substitutionVariables.push(attr);
		contextData.options = [];		
		return contextData;		
	},
	
	getSelectionDataV2: function () {						
		var contextData = {};
		contextData.rcfs = [];		
		var identifier = this.getIdentifier();
		var columnIDs = this.getAllColumnIndexes();
		var selectedRows = this.getSelectedRows();
		console.log ("selectedRows: ");
		console.log (selectedRows);
				
		dojo.forEach (selectedRows,
			function (row) {				
				var resourceAttrs = [];					
				for (var column in columnIDs) {
					if (column) {
						var cellValue = this.getValueAt (row, column);
						var attr = {};
						attr.name = column;
						attr.value = cellValue;
						attr.isNamingAttribute = "false";
						resourceAttrs.push(attr);
					}
				}
				contextData.rcfs.push (resourceAttrs);
			}, this);
		contextData.options = [];
		console.log ("contextData: ");
		console.log (contextData);
		//contextData.options.push ({name:"menuName",value:"listConnectionsMenu"});
		return contextData;		
	},
	
	getSelectionData: function () {
		//this.getModelData();
		var selectedRows = this.getSelectedRows ();
//		console.log ("selectedRows: " + selectedRows);

		var rowData = null;
		var columnIDs = this.getAllColumnIndexes();
		var identifier = this.getIdentifier();
		var rowJSON = {};
		
		dojo.forEach (selectedRows,
			function (row) {
				var firstTime = true;
				rowJSON.id = this.getValueAt (row, identifier);
			
				for (var column in columnIDs) {
					if (column) {
//						console.log ("getting cell value for row: " + row + " and column: " + column);
						var cellValue = this.getValueAt (row, column);
						rowJSON[column] = cellValue;
					}
				}
			}, this);

		
		var columnsArray = [];
		var columnJSON = {};
		var firstLoop = true;
		for (var c in columnIDs) {
			if (c) {
				columnJSON = {};
				columnJSON.field = c;
				columnJSON.isNamingAttribute = this.isNamingAttribute(c);
				columnsArray.push (columnJSON);
			}
		}
		
		var result = { selectedData: { columns: columnsArray, rows: rowJSON }}; 
		
//		console.log ("resultStr: " + resultStr);

		
//		var sample = { 
//		columns: [{ field: "srcToken", hidden: true },
//				  { field: "ManagedSystemName", label: "Managed System Name" },
//				  { field: "column_2", label: "baz" }],
//		
//		 rows: { srcToken: "1234", ManagedSystemName: "bar", column_2: "bang" }
//		 		};
		
		return (result);
	},
	isNamingAttribute: function (field) {
//		console.log ("enter isNamingAttribute");
//		var columns = this.grid.attr('structure')[0].cells[0];
//	  	var columns = this.grid.structure[0].cells[0];
		var columns = this.originalStructure.cells;
	  	if (columns[field]) {
		  	return columns[field].isNamingAttribute;
		} else {
			return (false);
		}
	},
	resize: function (size) {
		console.log ("enter TIPTable.resize: ");
		console.log (size);
		  
	  	if ((size) && (this.grid)) {
		  // remove height of footer
		  if (this.footerToolbar) {
		  	var coords = dojo.coords (this.footerToolbar.domNode);
		  	size.h = size.h - coords.h;
		  }
		  // remove height of toolbar
		  if (this.filterBar) {
		  	// the following line causes error in tip charts.  Please fix before uncommenting.
		    // this.filterBar.resetNubPos();
			coords = dojo.coords (this.filterBar.domNode);
			size.h = size.h - coords.h;
		  }
		  //Commenting the Extra Room changes as there is some extra padding in latest driver
		  // remove some extra room to make things fit better
		  //size.h = size.h - 15;
		  //size.w = size.w - 10;
		  
		  this.grid.autoHeight = false;
		  this.grid.autoWidth = false;
		  var	w = Number(size.w);
		  var h = Number(size.h);
		
//		  console.log ("calling ddojo.contentBox w/ w:: " + w + ", h: " + h);
//		  dojo.contentBox(this.grid.domNode, {w: w, h: h});
		  var updatedSize = { w: w, h: h};
		  this.grid.resize(updatedSize);
		  this.grid.update();
		  //add on 2009/07/09 for reorder columns because autosave is  true, don't need to make ajax request to server ,if auto save is false can try the following method
//		  if(this.gridParms.columnReordering == true){			   
//			  if(this.grid.layout!==null&&this.grid.structure!==null)
//			   { 
//			     pref=this.getPreferences();
//			    this.originalStructure=this.grid.layout; 
//				  if(pref!==null&&pref!==this.getPreferences()){
//			      this.savePreferences();
//	 			
//			   }  
//			  }
//			}
		  if(this.gridParms.columnReordering === true){			
			   
			  if(this.grid.layout!==null&&this.grid.structure!==null)
			   { 
			    this.originalStructure=this.grid.layout;  
			    
			  }
			}
	  	}

		if (this.filterBar) {
			try {
				this.filterBar.resetNubPos();
			} catch (e) {
				console.warn ("TIPTable.resize: error while resetting nub position:");
				console.warn (e);
			}
		}
	  	
	  	console.log ("exit TIPTable.resize");
    },
	onResize: function () {
//		console.log ("enter TIPTable.onResize");
		//var preferences = this.getPreferences();
		if (this.autoSavePreferences && this.viewLoaded && (!this.widgetParams || !this.widgetParams.standalone)) {
			this.savePreferences();
		} else {
//			console.log ("not saving preferences.  autoSavePreferences: " + this.autoSavePreferences + ", viewLoaded: " + this.viewLoaded);
		}		
	},
	
	savePagePref: function () {		
		if(this.tableBuilder){
			this.tableBuilder.saveUserPref();
		}
	},
	
	saveDOJOPreferences: function () {	
		if(this.tableBuilder){
			this.builder = this.tableBuilder;		
			var encodedCID = encodeURIComponent(this.widgetID);		
			var encodedProviderID = encodeURIComponent(this.builder.providerID);		
			var encodedDS = encodeURIComponent(this.builder.datasourceID);		
			var encodedPID = encodeURIComponent(this.global.chartProfileID);		
			//var widgetDefVersion = "2.1.0";
			var widgetDefVersion = this.tableBuilder.widgetDefinition.meta.version;
			var controller = "/ibm/tivoli/rest";
			var prefs = dojo.toJson(this.getDOJOPreferences());		
	        var kw = {
	        		sync: true,
	        		headers: { 'Content-Type': 'application/json',
	        			  	   'Content-Length': prefs.length
	        		},
	        		url: controller + "/providers/" + encodedProviderID + "/datasources/" + encodedDS + "/widgets/charts-2.1.0/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=user&profileID=" + this.global.chartProfileID + "&registryLocation=local",
	                putData: prefs
	         };          
	        dojo.xhrPut (kw);		
    	}		
	},
	
	getDOJOPreferences: function () {
		var prefs = { 
			"datasetsIdentifier":"id",
				"datasets": [{
					"id": this.tableBuilder.dataset.id					
				}],	
			"tablesIdentifier": "id",
			"tables": [ {
				"id": this.widgetID			     
			}]
		};
		
		prefs.datasets[0].columns = [];
		prefs.datasets[0].columnIdentifier = "id";
		if(this.originalStructure){
			var columns = this.originalStructure.cells;			
			for (var x in columns) {
				if (x) {
					prefs.datasets[0].columns[x] = {};
					prefs.datasets[0].columns[x].id = ""+x;	
					prefs.datasets[0].columns[x].label = columns[x].name;				
					prefs.datasets[0].columns[x].type = this.builder.widgetDefinition.datasets[0].columns[columns[x].field].type;
				}
			}
		}
		
		prefs.tables[0].view = [];
		prefs.tables[0].viewIdentifier = "id";
		if (this.originalStructure) {
		  	var columns = this.originalStructure.cells;
			for (var x in columns) {
				if (x) {
					prefs.tables[0].view[x] = {};
					prefs.tables[0].view[x].id = ""+x;
					prefs.tables[0].view[x].width = columns[x].width;
					prefs.tables[0].view[x].hidden = columns[x].hidden;
				}
			}			
		}
		
		return (prefs);
	},
	
	savePreferences: function () {
//		console.log ("enter TIPTable.savePreferences");
		// make sure that the grid has structure already.
		var preferences = this.getPreferences();
		
		if ((preferences !== null) && (preferences !== this.lastPreferences)) {
		    var kw = {
                      content:   {
                                    command: "saveTablePreferences",
                                    arg_fqTableId: this.tableID,
                                    arg_portletNamespace: this.global.namespace,
                                    arg_preferences: preferences
                                 },
                      timeout:   this.requestTimeout
                   };

   	      ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );
          this.lastPreferences = preferences;
       }
//       console.log ("exit TIPTable.savePreferences");
	},
	getPreferences: function () {
//		console.log ("enter TIPTable.getPreferences");
		var preferences = null;
		
		if (this.originalStructure) {
			//var ids = this.getViewColumnsIDs();
		  	var columns = this.originalStructure.cells;
			preferences = '{ "columns" : [ ';
		
			for (var x in columns) {
				if (x) {
					var visible = columns[x].hidden === undefined ? false : !columns[x].hidden;
					if (this.tableOptionsEnabled && this.tableOptionsDialog) {
						visible = this.tableOptionsDialog.getTableOptions().isColumnVisible(columns[x].field);
					}
					
					if (visible) {
						visible = "t";
					} else {
						visible = "f";
					}
					
					var viewIndex = this.getViewColumnIndex (columns[x].field);
					var width = columns[x].width;
					if (viewIndex !== null) {
						if ((this.grid) && (this.grid.getCell(viewIndex))) {
							width = this.grid.getCell(viewIndex).unitWidth;
						}
					} else {
						console.log ("no view index for column.field: " + columns[x].field);
					}
						
					preferences += ' {"id": "' + columns[x].field + '", "width":"' + width + '", "v":"' + visible + '"} ';
					
					if (x < columns.length - 1) {
						preferences += ", ";
					}
				}
			}
			preferences += " ] }";
//			console.log ("cell widths: ");
//			console.log (preferences);
		} else {
			console.log ("grid has no structure yet");
		}
				
		return (preferences);
	},
	getViewColumnIDs: function () {
//		console.log ("enter getViewColumnIDs");
//		console.log (this.originalStructure);
		//var columns = this.grid.attr('structure')[0].cells[0];
//	  	var columns = this.grid.structure[0].cells[0];
		var columns = this.originalStructure.cells;
	  	var columnIDs = [];
	  	for ( var i in columns ) {
	  		if (i) {
				columnIDs.push (columns[i].field);
			}
		}
		
		return (columnIDs);
	},
	getViewColumnIndex: function (id) {
		var viewColumnIDs = this.getViewColumnIDs();
		for (var i in viewColumnIDs) {
			if (i) {
				if (id == viewColumnIDs[i]) {
					return (i);
				}
			}
		}
		
		return (null);
	},
	/**************************************************************************
	* Initialize the toolbar with default buttons (like refresh)
	**************************************************************************/
	initializeToolbar: function() 
	{
		this._allToolbarButtons = [];
		
		var button = new ibm.tivoli.tip.dijit.TIPTableRefreshButton(
			{	id: this.id + "refreshButton",
			 	onClick: dojo.hitch (this, this.onRefresh) 
			});
		this.toolbar.addChild(button);
		this._allToolbarButtons.push( button );
				
		if (this.multiSelect) {
			this.toolbar.addChild (new dijit.ToolbarSeparator());
		
			button = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.resources_.SELECT_ALL, 
					showLabel: false, 
					iconClass: "selectAllIcon",
				 	onClick: dojo.hitch (this, this.selectAll) 
				});
			this.toolbar.addChild(button);
			this._allToolbarButtons.push( button );
	
			button = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.resources_.DESELECT_ALL, 
					showLabel: false, 
					iconClass: "deselectAllIcon",
				 	onClick: dojo.hitch (this, this.deselectAll) 
				});
			this.toolbar.addChild(button);
			this._allToolbarButtons.push( button );
		}
		
		if (this.tableOptionsEnabled) {
			console.log ("enabling table options");
			this.toolbar.addChild (new dijit.ToolbarSeparator());
		
			button = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.resources_.TABLE_PREFERENCES, 
					showLabel: false, 
					iconClass: "tableOptionsIcon",
				 	onClick: dojo.hitch (this, this.showTableOptions) 
				});
			this.toolbar.addChild(button);
			this._allToolbarButtons.push( button );
		} else {
			console.log ("NOT enabling table options");
		}
		
	    if (this.toolbarHidden_) {
			this.toggleToolbarOff();
		} else {
			this.toggleToolbarOn();
		}
	},
	selectAll: function () 
	{
		var count = this.grid.getTotalRows();
		for (var i=0; i<count; i++) {
			this.grid.selection.addToSelection(i);
		}
		
		this.updateFooter (this.gridParms.store.id);
	},
	deselectAll: function () 
	{
		this.grid.selection.deselectAll();
		this.updateFooter (this.gridParms.store.id);
	},
	onRefresh: function() {
        // What is going on here?
        // Previously, the preceding three lines were used in this function to refresh
        // the table.  Create a new model, set the model, and issue the event.  However,
        // the problem is that TIPTable gets its data from the server, so the new model
        // was set prior to it having any data.  This resulted in the table 
        // "flashing".  That is the table would go all blank, then turn around and fill
        // with the data from the server.  This didn't look good, so the below code fixes
        // this.  A callback was added to the store so that when it finishes handling
        // data from the server, it will call the callback.  This enables us to first 
        // create the model, and load its first page, then swap it in to the table.
        
        // Create the callback function that will swap in the new model when it has some data
        var cb = dojo.hitch(this,function(){  console.debug("----- Inside the refresh callback ----");
                                              this.grid.setLoadCompleteCallback(null);
                                              // I found that the following update is needed when only
                                              // one row is in the model.
//                                              this.grid.update();
                                              this.updateFooter(this.gridParms.store.id);
                                              dojo.publish (this.id + "#Refresh", [ "Refresh" ]);
                                            });
                                            
        this.grid.setLoadCompleteCallback(cb);  // set the callback
        this.grid._refresh(true);
	},
	refreshWithArgs: function (args) {
		this.tableArgs = args;
		var dataQuery = {query:this.query};

	  	if (this.tableArgs) {
	  		for (var key in this.tableArgs) {
	  			if (key) {
	  				dataQuery[key] = this.tableArgs[key];
	  			}	
	  		}
	  	}
	
	// TODO: We still need to set the widgetID a different way  	
//	  	if (this.widgetID !== null) {
//			dataQuery.widgetID = this.widgetID;
//		}
	  	
	  	this.grid.setQuery(dataQuery);	
	  	this.onRefresh();
	},
	updateFooter: function (storeID) {
//		console.log ("enter TIPTable.updateFooter");
		if (storeID == this.gridParms.store.id) {
			var total = this.grid.getTotalRows();
			var numSelected = this.grid.selection.getSelectedCount();
			var footerText = dojo.string.substitute(this.resources_.TABLE_FOOTER_TEXT, { 0: numSelected, 1: total });
        	this.getFooterToolbar().setInfoAreaHTML( footerText );
        }
	},
	getFooterToolbar: function () {
		return (this.footerToolbar);
	},
	getToolbar: function () {
		return (this.toolbar);
	}, 
	onSearch: function (tipSearchField, event) 
	{
//		console.log ("enter onSearch with search value: " + tipSearchField.searchField.value);
		
		if (this.search) 
		{
			var columns = this.searchField.getSelectedColumns();
			this.search (columns, tipSearchField.searchField.value);
		}
	},
	search: function (columns, searchFor) {		
		if(this.tableBuilder){
			var queryOptions = {ignoreCase: true};
			/*
			if(this.lastSearchColumns){
				for (var x in this.lastSearchColumns) {
					if (x) {
						this.query[this.lastSearchColumns[x]] = {value:"", op:"CONTAINS", sensitive:false};
					}
				}
			}
			*/
			this.query.navModel.search = {};
			var search = this.query.navModel.search;
			search.term = searchFor;
			search.attributes = [];	
			for (var x in columns) {
				if (x) {
					//this.query[columns[x]] = {value:searchFor, op:"CONTAINS", sensitive:false};
					search.attributes.push(columns[x]);
				}
			}	
			//this.lastSearchColumns = columns;		
			this.grid.setQuery(this.query,queryOptions);
		}else{
			this.query = {};
			for (var x in columns) {
				if (x) {
					this.query[columns[x]] = searchFor;
				}
			}
		// TODO: We still need to set the widgetID a different way	
//			if (this.widgetID !== null) {
//				this.query.widgetID = this.widgetID;
//			}

//			console.log ("query is: ");
//			console.log (this.query);
			this.grid.setQuery(this.query);
		}	
	},
	
	toggleToolbar: function () {
       console.info("toggleToolbar");
       		if (this.toolbarHidden_) {
			this.toggleToolbarOn();
		} else {
			this.toggleToolbarOff();
		}
		this.saveToolbarStatus(this.toolbarHidden_);
	},
	saveToolbarStatus: function(toolbarHidden_) {
	  	if(this.tableBuilder.preferencesDialog === null || this.tableBuilder.preferencesDialog == undefined){
			this.tableBuilder.preferencesDialog = new ibm.tivoli.tip.charts.dijit.ChartPreferences ( 
					{ global: this.global,				  
					  tableBuilder: this.tableBuilder,
					  isTableFirst: this.tableBuilder.isTableFirst
					} 
				);
		}
		this.tableBuilder.preferencesDialog.startup();
		this.tableBuilder.preferencesDialog.builder.toolbarHidden_ = toolbarHidden_;
		this.tableBuilder.preferencesDialog.saveUserPreferences(false);
	},
	toggleToolbarOn: function () {	
		console.info("toggleToolbarOn ");
		this.toolbarHidden_ = false;
		var animatedToolbar = dojo.fx.wipeIn ({    
			node: this.filterBar.id+"toolbar",
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                	
                })
			});		
		animatedToolbar.play();
		var animatedToolbar1 = dojo.fx.wipeIn ({    
			node: this.filterBar.id+"searchbar",
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                	
                })
			});		
		animatedToolbar1.play();
		var animatedToolbar1 = dojo.fx.wipeIn ({    
			node: this.filterBar.id+"toolbarTR",
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                	
                })
			});	
		dojo.style(this.filterBar.toolbar,"height","9px");
		dojo.style(this.filterBar.nub,"position","absolute");
		dojo.removeClass(this.filterBar.nub,"nubClosed");
		dojo.addClass(this.filterBar.nub,"nubOpen");
		this.filterBar.stateMinimized=false;
		dojo.style(this.filterBar.nub,"display","block");
	},
	toggleToolbarOff: function(){
		console.info("toggleToolbarOff");
		this.toolbarHidden_ = true;
		
		var animatedtoolbarOff = dojo.fx.wipeOut ({
				node: this.filterBar.id+"toolbar",
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                
                })
			});
		animatedtoolbarOff.play();
		var aniOff2 = dojo.fx.wipeOut ({
			node: this.filterBar.id+"searchbar",
		    duration: 500,
            onEnd: dojo.hitch(this, function() {
                
            })
		});
		aniOff2.play();
		dojo.style(this.filterBar.nub,"position","relative");
		//dojo.style(this.filterBar.nubArea,"height","10px");
				
		this.filterBar.stateMinimized=true;
		dojo.removeClass(this.filterBar.nub,"nubOpen");
		dojo.addClass(this.filterBar.nub,"nubClosed");
		
	},
	onRowClick: function (evt) {
		console.log ("enter TIPTable.onRowClick");
		this.updateFooter (this.gridParms.store.id);
	},
	showTableOptions: function () 
	{
//		console.log ("enter TIPTable.showTableOptions");
		this.tableOptionsDialog = new ibm.tivoli.tip.dijit.TIPTableOptionsDialog ( 
				{ table: this } 
			);
		
		this.tableOptionsDialog.show();
	},
	getColumnById: function (id) {
		var viewIndex = this.getViewColumnIndex (id);
		var column = this.grid.getCell (viewIndex);
//		console.log ("TIPTable.getColumnById ( " + id + "). returning column: ");
//		console.log (column);
		return (column);
	},
	getStore: function () {
		return (this.gridParms.store);
	},
	destroy: function ()
	{
		this.inherited("destroy",arguments );
		if ( this._allToolbarButtons )
		{
			for ( tbb in this._allToolbarButtons )
			{
				if(this._allToolbarButtons[ tbb ]){
					this._allToolbarButtons[ tbb ].destroy();
				}
			}
		}
		if(this.toolbar){
			this.toolbar.destroy();
		}
		if(this.footerToolbar){
			this.footerToolbar.destroy();
		}		
	}
	
});
	

}
