/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableSearchField_mod"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableSearchField_mod"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.Dialog");
dojo.require("dijit.Menu");
dojo.require("dijit.Tooltip");
dojo.require("ibm.tivoli.tip.dijit.TIPTableDropDownButton");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw", "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt-br,ro,ru,sl,sv,tr,zh-cn,zh-tw");

dojo.provide("ibm.tivoli.tip.dijit.TIPTableSearchField_mod");

dojo.declare("ibm.tivoli.tip.dijit.TIPTableSearchField_mod",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,
  
  /* The TIPTable that this search bar is attached to */
  table: null,
  
  _ALL_COLS_NAME: "QF_ALL_COLS",
  
  /** An array of column names that should participate in filtering **/
  columnsToFilterOn: { "QF_ALL_COLS": false },
  
  /** Keeps track of all topic subscriptions to cleanly destroy later **/
  topics: [],
  
  _qf_arrow_src: dojo.moduleUrl("ibm.tivoli.tip.dijit","themes/images/qf_arrow.gif"),
  
  /** Keeps track of all event connections **/
  objectConnections: [],
  
  /** Keeps track of all children widgets in dropdown **/
  childrenWidgets: [],
  
  templateString:"<div class=\"quick-filter\" >\r\n<table dojoAttachPoint=\"qflayout\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\r\n<tbody>\r\n<tr>\r\n<td dojoAttachPoint=\"colFilter\" class=\"qf-lcap\" width=\"24px\" valign=\"top\" dojoAttachEvent='onmouseover:_onHover,onmouseout:_onUnHover'>\r\n</td>\r\n<td class=\"qf-mid\" width=\"170px\" valign=\"middle\">\r\n<label style=\"width:100%\" title=\"${resources_.SEARCH_TEXT}\">\r\n<input style=\"width:100%\" dojoAttachPoint=\"searchField\" class=\"qf-textfield-label\" type=\"text\" valign=\"middle\" dojoAttachEvent='onfocus:_onFocus,onblur:_onBlur,onkeypress:_onKeyPress' />\r\n</label>\r\n</td>\r\n<td dojoAttachPoint=\"colFilterTail\" class=\"qf-rcap\" width=\"24px\" valign=\"top\"/>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n",

  constructor: function( parms ) 
  {
  	this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
  	this.lastColumns = null;
  },
  
  postCreate: function()
  {
	  if(dojo.getComputedStyle(dojo.body()).direction == "rtl"){
		  this.colFilter.className="qf-lcap-bidi";
		  this.colFilterTail.className="qf-rcap-bidi";
		  this.qflayout.setAttribute("align","left");
		  this.qflayout.setAttribute("padding-left","30px");
	  }else{
		  this.colFilter.className="qf-lcap";
		  this.colFilterTail.className="qf-rcap";
		  this.qflayout.setAttribute("align","right");
		  this.qflayout.setAttribute("padding-right","30px");
	  }
    if ( this.table !== null )
    {
      this.setTable( this.table );
    }        
  },  
   
  /********************************************************************
  * This method must be called to set the underlying table that the 
  * search bar will filter on.  As soon as this method is called
  * the table is queried for its "structure" (columns) and the dropdown
  * column filter dialog is populated
  *********************************************************************/
  setTable: function( table )
  {
  	// Save a reference to the table
  	this.table = table;
  	
  	this.clear(); //ensure that we start with a fresh slate
  	  	
  	var div  = document.createElement( 'DIV' );
  	var div2 = document.createElement( 'DIV' );
  	div2.className="qf-col-filter-title";	  
  
  	div2.appendChild( document.createTextNode( this.resources_.FILTER_ON ) );
  	div.appendChild( div2 );

	var columns = [];
	var i = 0;
	var j = 0;
	var first = true;
	
	table.views.forEach( function( view, k )
	{
		if ( view.structure.cells )
		{
			for ( var i in view.structure.cells )
			{
				if (i) {
					for ( var j in view.structure.cells[i] )
					{
						if (j) {
						 	var v = view.structure.cells[i][j];				
		    	         	if (v.field !== undefined) {
                	         	columns.push( v );
	                 		}
	                 	}
					}			
				}
			}
		}
	});  	
  	
  	var checkedValue;
  	for ( i in columns )
  	{
  	  if (i) {
	    	if (columns[i].filter == false)
    			continue;

  			div2 = document.createElement( 'DIV' );
  			div2.className="qf-col-chkbox-label-row";
  		
  			if ( first )
  			{
  				checkedValue = true;
  				first = false;
  			}
  			else
  				checkedValue = false;
  
  			checkbox = new dijit.form.CheckBox( { id     : table.id + columns[i].name,
  											  pId    : table.id,
  											  columnID: columns[i].field,
  	                                          name   : table.id + columns[i].name,
  	                                          checked: checkedValue } );

			this.childrenWidgets[ checkbox.id ] = checkbox;
		
			checkbox.onAllColsFilter = function() {
				this.attr ("checked", false);
			};
		
			checkbox.onCheckedEvent = function () {
	  			if ( this.checked )
	  			{
			  		dojo.publish( this.pId + "_filterByCol", ["Filter on individual columns"] );		
	  			}
			};  	           
		
			this.topics[ columns[i].name ] = dojo.subscribe( table.id + "_filterOnAll", checkbox, "onAllColsFilter" );                               
  	    
			this.objectConnections[ columns[i].name ] = dojo.connect( checkbox, "_setCheckedAttr", checkbox, "onCheckedEvent" );  	                                          
  	                                          
			div2.appendChild( checkbox.domNode );  	                            

			label = document.createElement( 'LABEL' );
			label.htmlFor = checkbox.id;
			label.title = columns[i].name;
			label.className = "qf-col-chkbox-label";
		
			label.appendChild( document.createTextNode( columns[i].name ) );
		
			div2.appendChild( label );  	                                         		             
  		
  			div.appendChild( div2 );  		
  		}
  	}
  	  	
  	var button = new dijit.form.Button( { id: table.id + "close_btn",
                                        type: "submit", 
                                        onClick: dojo.hitch (this, "onFilterOK"),
  								       label: this.resources_.OK } );

	this.childrenWidgets[ button.id ] = button;	  								       
  								     
	div.appendChild( button.domNode );  								     
  	
  	var tooltipDialog = new dijit.TooltipDialog( { id: table.id + "gf_tooltipdialog" } );

	this.childrenWidgets[ tooltipDialog.id ] = tooltipDialog;	  								       
  	  	
  	tooltipDialog.containerNode.appendChild( div );
  	
  	/** OVERLOAD to allow our own styling to be added **/
//  	tooltipDialog.orient = function(/*Object*/ corner)
//  	{
		// summary: configure widget to be displayed in given position relative to the button
//		this.domNode.className="dijitTooltipDialog " +" dijitTooltipAB"+(corner.charAt(1)=='L'?"Left":"Right")+" dijitTooltip"+(corner.charAt(0)=='T' ? "Below" : "Above" ) + " qf-TooltipDialog";
//	};  	
  	
  	tooltipDialog.execute = function( args )
  	{  		
  	    this.columnsToFilterOn = [];
  	    
  		for ( var i in args )
  		{
  			if (i) {
				this.columnsToFilterOn[i] = args[i][0] ? true : false ;
			}
  		}  	
  	};
  	
	var btn = new ibm.tivoli.tip.dijit.TIPTableDropDownButton( { id: table.id + "_coltrigger", 
												dropDown: tooltipDialog,
												label: "",
												baseClass: "qf-col-trigger" } );
												
	this.tooltip_dropdownhelp = new dijit.Tooltip({label:this.resources_.SEARCH_DROP_DOWN_HELP, connectId:[btn.id]}, document.createElement("div"));
												
	
	this.childrenWidgets[ btn.id ] = btn;	  								       

	this.colFilter.appendChild( btn.domNode );
		
	btn.startup();
	
//	var downArrowSpan =  dojo.query("span.dijitArrowButtonChar", btn.domNode );	
	
//	dojo.query("span.dijitButtonText", btn.domNode ).orphan();
	
//	downArrowSpan[0].innerHTML = "";
//	dojo.removeClass( downArrowSpan[0], "dijitArrowButtonChar" );
//	dojo.removeClass( downArrowSpan[0], "dijitArrowButtonInner" );
//	downArrowSpan[0].style.padding="0px";
	
//	var image = dojo.doc.createElement( 'IMG' );	
//	image.src = this._qf_arrow_src;
//	image.border = 0;
//	image.style.padding="0px";
//	image.style.margin="0px";
//	image.alt = this.resources_.SEARCH_DROP_DOWN_HELP;
	
//	downArrowSpan[0].appendChild( image );	
  },
  
  onFilterOK: function () {
  	console.log ("enter onFilterOK");
	var columns = this.getSelectedColumns();
	if (this.columnsEqual (columns, this.lastColumns)) {
		console.log ("columns match.  not calling search");
	} else {
		console.log ("calling search");
  		dojo.publish (this.id + "searchInvoked", [this, null]);
  		this.lastColumns = columns;
	}
  },
  
  columnsEqual: function (columns1, columns2) {
  	if ((columns1 === null) && (columns2 === null)) {
  		return (true);
  	} else if ((columns1 === null) || (columns2 === null)) {
  		return (false);
  	} else if (columns1.length !== columns2.length) {
  		return (false);
  	} else {
		for (var x in columns1) {
			if (columns1[x] !== columns2[x]) {
				return (false);
			}
  		}
  		
  		return (true);
  	}
  },
  
  _onFocus: function()
  {
	this.domNode.className="quick-filter-focus";  
  },
  
  _onBlur: function()
  {
	this.domNode.className="quick-filter";
  },
  
  _onKeyPress: function(event)
  {
  	if (event.keyCode == 13) {
	  	event.cancelBubble = true;
  		event.returnValue = false;
  		dojo.publish ("onEnter", [this, event]);
  		dojo.publish (this.id + "searchInvoked", [this, event]);
	}
  },
  
  _onHover: function()
  {
	  if(dojo.getComputedStyle(dojo.body()).direction == "rtl"){
		  this.colFilter.className="qf-lcap-over-bidi";
	  }else{
		  this.colFilter.className="qf-lcap-over";
	  }
  },
  
  _onUnHover: function()
  {
	  if(dojo.getComputedStyle(dojo.body()).direction == "rtl"){
		this.colFilter.className="qf-lcap-bidi";
	  }else{
		this.colFilter.className="qf-lcap";
	  }
  },
  
  _setFilterCol: function ()
  {  	
  },
  

  getSelectedColumns: function ()
  {
  	var result = [];
  	for (var y in this.childrenWidgets) {
  		if (y) {
  			if (this.childrenWidgets[y].checked) {
	  			if (this.childrenWidgets[y].columnID !== undefined ) {
	  				result.push (this.childrenWidgets[y].columnID);
	  			}
  			}
  		}
  	}
  	
	return (result);
  },
  
  /*************************************************************
  * Clears the contents of the search drop down to be recreated
  *************************************************************/
  clear: function()
  {
  	/** Destroy all subscriptions **/
  	for ( var i in this.topics )
  	{
  		if (i) {
  			dojo.unsubscribe( this.topics[i] );
  		}
  	}
  	
  	delete this.topics;
  	this.topics = [];

  	/** Destroy all event connections **/
  	for ( i in this.objectConnections )
  	{
  		if (i) {
	  		dojo.disconnect( this.objectConnections[i] );
	  	}
  	}  	

  	delete this.objectConnections;
  	this.objectConnections = [];
  	
  	/** Destroy all children widgets **/
  	for ( i in this.childrenWidgets )
  	{
  		if (i) {
  			this.childrenWidgets[i].destroy();
  		}
  	}  
  	
  	if ( this.tooltip_dropdownhelp )
  	{
  		this.tooltip_dropdownhelp.destroy();
  	}

  	delete this.childrenWidgets;
  	this.childrenWidgets = [];
  	
  	delete this.columnsToFilterOn;
  	this.columnsToFilterOn = [];
  },
  
  /*************************************************************
  * Destroy this widget -- remove all subscriptions and event
  * connections
  *************************************************************/
  destroy: function()
  {  	
	this.inherited( "destroy", arguments );
  	this.clear();
  	/** call super **/
  	
  }
  
});

}
