/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPWizard"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPWizard"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007, 2008, 2009, 2010 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

/*
  test pages for using the wizard:
   - basic example:                http://eischeid.bluehost.ibm.com/designs/misc/wizdemo/wizdemo_widget.html
   - fixed size:                   http://eischeid.bluehost.ibm.com/designs/misc/wizdemo/wizdemo_widget_fixed.html
   - horizontal table of contents: http://eischeid.bluehost.ibm.com/designs/misc/wizdemo/wizdemo_widget_horizontal.html
   
*/

 
dojo.provide("ibm.tivoli.tip.dijit.TIPWizard");
dojo.require("dijit._Widget");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackContainer");
dojo.require("dojo.i18n");
dojo.require("dijit.form.Button");

dojo.declare(
	"ibm.tivoli.tip.dijit.TIPWizard", 
    [ dijit._Widget ],
{

  //unique string identifier that will be used to make elements of this widget instance unique. 
  id: "",
  
  //array of URL's. include one URL for each page you want in the wizard	
  pageLocations: null,
  
  //Labels that will appear in the table of contents; each element corresponds to an element in the pageLocations array
  pageLabels: null,
  
  //array of events/functions (each event specified as a string), one for each page. this will fire when the page has been loaded and parsed during initialization
  pageInit: null,  

  //array of events/functions (each event specified as a string), one for each page. this will fire when the page is navigated to by the user
  onPageShow: null,
  
  //array of events/functions (each event specified as a string), one for each page. this will fire before the page is navigated away from. Return false from your function to keep the user on the current page. return true to allow navigation to the next page.
  onPageBeforeHide: null,
  
  //user-specified event/function for what action the Finish button performs
  onFinish: null,
  
  //user-specified event/function for what action the Cancel button performs
  onCancel: null,
  
  //table of contents layout for the wizard; values are either "vertical" or "horizontal"
  tocLayout: "vertical",
  
  //these will be references to dijit button objects; should probably make these private vars
  backBtn: null,
  nextBtn: null,
  finishBtn: null,
  cancelBtn: null,
  
  //if true, wizard will size to dimensions of source node; if false, will resize to 100% container and resize with the container
  fixedSize: false,
  
  //fixed width; only applies when fixedSize = true
  fixedWidth: "800px",
  
  //fixed height; only applies when fixedSize = true
  fixedHeight: "600px",
  
  //width of table of contents area
  tocWidth: "200px",
  
  //whether or not wiz should be auto destroyed when user clicks cancel button
  //if you have a function defined for the onCancel event, then destroyOnCancel has no effect 
  destroyOnCancel: false,
  


/******************************************************************************************
******************************************************************************************/
constructor: function() {

   //private vars
   this.TAB_COUNT = 0;
   this.MAX_TAB_COUNT = 0;   
   this.currTabIdx = 0;  
   this.nextBtnConnectHandle = null;
   this.backBtnConnectHandle = null;
   this.finishBtnConnectHandle = null;
   this.cancelBtnConnectHandle = null;
  
   this._onPageShow = new Array();
   this._onPageBeforeHide = new Array();
  
   /* this will be an array of booleans, one array element per page. use the setPageVisible method
      to take pages in or out of the wizard flow. You can use this for branching type of functionality
	  or however you wish.
   */
   this.pageVisibilityFlags = null;   

   this.newChild = null;
   this.contentDiv = null;
   this.contentDivId = null;
   this.navTab = null;
   this.navTabId = null;
   this.navTabClass = null;
   
   this.tabCompleteClass = "";
   this.tabCurrentClass = "";
   this.tabNotCompleteClass = "";
   this.tocBackgroundClass = "";
   
   this.subStepClassHidden = "WizardTabSubStepHidden";
   this.subStepClassVisible = "WizardTabSubStepVisible";
   
   //this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");

},

/******************************************************************************************
******************************************************************************************/
postCreate: function() {
  
  if (this.tocLayout == "vertical")
  {
  	this.tabCompleteClass = "WizardTabCompleted";
    this.tabCurrentClass = "WizardSelTab";
    this.tabNotCompleteClass = "WizardTab";
    this.tocBackgroundClass = "WizardTabBackground";
    
  }
  
  if (this.tocLayout == "horizontal")
  {
  	this.tabCompleteClass = "WizardTabCompletedHorizontal";
    this.tabCurrentClass = "WizardSelTabHorizontal";
    this.tabNotCompleteClass = "WizardTabHorizontal";
    this.tocBackgroundClass = "WizardTabBackgroundHorizontal";
  	
  }
  
  
  //if no id is given, we can still garantee uniqueness by using the unix epoch as the id
  if (this.id == "")
  {
  	d = new Date();
  	this.id = "" + d.getTime();
  }
	
	
  this.wizInit();
	
},


/******************************************************************************************
  main wizard initialization function; this is the function to construct and show the 
  wizard. Call this only after page is loaded and parsed.
******************************************************************************************/
wizInit: function()
{
  this.writeWizardTemplate();
  this.loadContent();
  this.showTab(0);
  
},	

/******************************************************************************************
  Call this function to show or hide specific pages. This can be useful
  for creating branch points, for example.
  
  If you set a page to false with this function, it will not appear in the wizard sequence. There
  is one element in the pageVisibilityFlags array for each page in the wizard.
  
  note that this function will not work well if you set the currently visible page to false; 
  the current page won't be hidden. This behavior could be changed, but I don't see a use case for it.

******************************************************************************************/
setPageVisible: function(idx, visible)
{
   var i = 0;
   var visPageCount = 0;
   var currVisPage = 0;

   this.pageVisibilityFlags[idx] = visible;

   if (visible)
   {
   	 //TODO: make sure "tableCell" works below IE7 and below FF3.5
   	 if (this.tocLayout == "horizontal")
   	   dojo.style(dojo.byId(this.id + "wizard_t" + idx), "display", "tableCell");
     
	 if (this.tocLayout == "vertical")
       dojo.style(dojo.byId(this.id + "wizard_t" + idx), "display", "block");
   }    
   else
   {
   	 dojo.style(dojo.byId(this.id + "wizard_t" + idx), "display", "none");
   }
    

   //get number of visible pages
   //for (i = 0; i < this.TAB_COUNT; i++) if (this.pageVisibilityFlags[i]) visPageCount++;

},


/******************************************************************************************
  internal function to dynamically create the content pages and populate the 
  wizard; this is only called after the wizard framework/template has been
  initialized via writeWizardTemplate()
******************************************************************************************/
loadContent: function()
{

var i = 0;

this.TAB_COUNT = this.pageLocations.length;
this.MAX_TAB_COUNT = this.pageLocations.length;
this.pageVisibilityFlags = new Array(this.TAB_COUNT);
this.newChild = new Array(this.TAB_COUNT);

var navTabTable;
var navTabTableBody;
var navTabTableRow;

//var navTabImg = null;

if (this.tocLayout == "horizontal")
{
  navTabTable = document.createElement("table");
  dojo.attr(navTabTable, "border", "0");  
  dojo.style(navTabTable, "borderCollapse", "collapse");
  dojo.style(navTabTable, "borderSpacing", "0");
  dojo.style(navTabTable, "border", "none");
  
  navTabTableBody = document.createElement("tbody");
  navTabTableRow = document.createElement("tr");
  
}


for (i = 0; i < this.TAB_COUNT; i++)
{
	
	 this.newChild[i] = null;
	 
	 //if a page initialization function is defined, add it in, otherwise no page init
	 if (this.pageInit)
	 {
	 	
	 	if (this.pageInit[i])
		{
		    this.newChild[i] =  new dijit.layout.ContentPane({
			                      id:this.id + "page" + i,
		    	                  href:this.pageLocations[i],
		                          title:this.pageLabels[i],
		                          refreshOnShow:false,
							      onLoad: window[this.pageInit[i]]
							    },
		                        dojo.doc.createElement('div')
		                       );
									  
	    }
	    else
	    {
	    	this.newChild[i] =  new dijit.layout.ContentPane({
		                      id:this.id + "page" + i,
	    	                  href:this.pageLocations[i],
	                          title:this.pageLabels[i],
	                          refreshOnShow:false 
						    },
	                        dojo.doc.createElement('div')
	                       );
	    	
	    	
	    }
	 	
	    
	 }
	 else
	 {
		 this.newChild[i] =  new dijit.layout.ContentPane({
		                      id:this.id + "page" + i,
	    	                  href:this.pageLocations[i],
	                          title:this.pageLabels[i],
	                          refreshOnShow:false 
						    },
	                        dojo.doc.createElement('div')
	                       );
	 }
	 
    
	 if (this.onPageShow)
	 {
	   if (this.onPageShow[i])
		{
 		  if (this.onPageShow[i] != "")
			this._onPageShow[i] = this.onPageShow[i];		 
		  else
 		    this._onPageShow[i] = null;		  
	   }
		else
		{
		   this._onPageShow[i] = null;
		}
	 }
	 else
	 {
	   this._onPageShow[i] = null;
	 }
	 
	 if (this.onPageBeforeHide)
	 {
	   if (this.onPageBeforeHide[i])
		{
 		  if (this.onPageBeforeHide[i] != "")
			this._onPageBeforeHide[i] = this.onPageBeforeHide[i];		 
		  else
 		    this._onPageBeforeHide[i] = null;		  
	   }
		else
		{
		   this._onPageBeforeHide[i] = null;
		}
	 }
	 else
	 {
	   this._onPageBeforeHide[i] = null;
	 }	 
								  
    dijit.byId(this.id + "mainTabContainer").addChild(this.newChild[i]);
    this.newChild[i].startup();

    
    
    if (this.tocLayout == "vertical")
    {
      this.navTab = document.createElement("div");	
    }
    
    if (this.tocLayout == "horizontal")
    {
      this.navTab = document.createElement("td");
	  dojo.attr(this.navTab, "valign", "bottom");	
      
	  /*
      navTabImg = document.createElement("img");
      dojo.addClass(navTabImg, "WizardTabCompletedMarker");
      dojo.attr(navTabImg, "id", this.id + "wizard_t" + i + "Img");
      dojo.attr(navTabImg, "border", "0");        
      
      this.navTab.appendChild(navTabImg.cloneNode(true));
      */
    }    
    
    dojo.attr(this.navTab, "id", this.id + "wizard_t" + i);
        
    //assumes starting on first page of wizard
    if (i == 0)
		dojo.addClass(this.navTab, this.tabCurrentClass);
    else
		dojo.addClass(this.navTab, this.tabNotCompleteClass);


    if (this.pageLevels)
    {
      if (this.pageLevels[i] == "2")
        dojo.addClass(this.navTab, this.subStepClassVisible);
    }
       
    

    navTabText = document.createTextNode(this.pageLabels[i]);
    this.navTab.appendChild(navTabText.cloneNode(true));

    if (this.tocLayout == "horizontal")
    {
      navTabTableRow.appendChild(this.navTab.cloneNode(true));
    } 
    
    if (this.tocLayout == "vertical")
    {
      dojo.byId(this.id + "wizardNavTabContainer").appendChild(this.navTab.cloneNode(true));
    }
    
    
}

if (this.tocLayout == "horizontal")
{
  navTabTableBody.appendChild(navTabTableRow.cloneNode(true));
  navTabTable.appendChild(navTabTableBody.cloneNode(true));
  dojo.byId(this.id + "wizardNavTabContainer").appendChild(navTabTable.cloneNode(true));  
}

this.currTabIdx = 0;

//default is all pages visible
for (i = 0; i < this.TAB_COUNT; i++) this.pageVisibilityFlags[i] = true;


},

//figure out which, if any, substeps to show in the table of contents.
//hide or show as appropriate, based on current page
//this only applies when substeps are defined
calcSubStepToc: function()
{
  if (!(this.pageLevels)) return;	
	
  var i = 0;
  var parentFlag = false;
  var currentHasChildren = ((this.pageLevels[i] == "1") && (this.pageLevels[this.currTabIdx + 1] == "2"));
  
 // alert('currentHasChildren ' + currentHasChildren); 
  
  for (i = this.currTabIdx; i >= 0; i--)
  {  	
  	if (this.pageLevels[i] == "1") parentFlag = true;
  	
  	if (this.pageLevels[i] == "2")
  	{
  	  if (!parentFlag)  	       
        dojo.removeClass(dojo.byId(this.id + "wizard_t" + i), this.subStepClassHidden);	   	
  	  else  	         
       dojo.addClass(dojo.byId(this.id + "wizard_t" + i), this.subStepClassHidden); 
  	}
  }
  
  var hitNextParent = false; 
  
  //ensure all appropriate, non-active substeps are hidden
  for (i = (this.currTabIdx + 1); i < this.pageLevels.length; i++)
  {
  	if (currentHasChildren)
  	{
  	  hitNextParent = (this.pageLevels[i] == "1");
     // alert('hitNextParent ' + hitNextParent);
      
  	  if ((this.pageLevels[i] == "2") && (!hitNextParent))  	      
        dojo.removeClass(dojo.byId(this.id + "wizard_t" + i), this.subStepClassHidden);
      else
        dojo.addClass(dojo.byId(this.id + "wizard_t" + i), this.subStepClassHidden);
  	}
  	else
  	{
  	  if (this.pageLevels[i] == "2") dojo.addClass(dojo.byId(this.id + "wizard_t" + i), this.subStepClassHidden);
  	}
  }
  
  
  
  	
},

/******************************************************************************************
  Use to jump to a specific tab page. For example, you may need to
  skip a page based on the user's choices.
  
  if no index is passed in, then uses this.currTabIdx as the value for the page to show
******************************************************************************************/
showTab: function(idx)
{

  if (idx) this.currTabIdx = idx;
  
    
  //this is what actually changes the visible stackcontainer page
  dijit.byId(this.id + "mainTabContainer").selectChild(dijit.byId(this.id + "page" + this.currTabIdx));
  
  dijit.byId(this.id + "btnNext").attr("disabled", !((this.currTabIdx + 1) < this.TAB_COUNT));
  dijit.byId(this.id + "btnFinish").attr("disabled", ((this.currTabIdx + 1) < this.TAB_COUNT));
  dijit.byId(this.id + "btnBack").attr("disabled", !(this.currTabIdx > 0));
    
  //if next button is enabled  
  if ((this.currTabIdx + 1) < this.TAB_COUNT)
  {
    if (!(this.nextBtnConnectHandle)) this.nextBtnConnectHandle = dojo.connect(this.nextBtn.domNode, "onclick", this, "navNext");
  }
  else
  {    	
  	//note: the disconnect is needed because the onclick event will still fire in IE even
  	//      when the button is disabled
    if (this.nextBtnConnectHandle) dojo.disconnect(this.nextBtnConnectHandle);   
    this.nextBtnConnectHandle = null;
  }
  
  //if back button is enabled
  if (this.currTabIdx > 0)
  {
  	if (!(this.backBtnConnectHandle)) this.backBtnConnectHandle = dojo.connect(this.backBtn.domNode, "onclick", this, "navBack");
  }
  else
  {
  	//note: the disconnect is needed because the onclick event will still fire in IE even
  	//      when the button is disabled
    if (this.backBtnConnectHandle) dojo.disconnect(this.backBtnConnectHandle);	
    this.backBtnConnectHandle = null;
  }
  
 
  for (i = 0; i < this.currTabIdx; i++) dojo.byId(this.id + "wizard_t" + i).className = this.tabCompleteClass;
  dojo.byId(this.id + "wizard_t" + this.currTabIdx).className = this.tabCurrentClass;
  for (i = (this.currTabIdx + 1); i < this.TAB_COUNT; i++) dojo.byId(this.id + "wizard_t" + i).className = this.tabNotCompleteClass;
  
  
  
/*
  if (this.tocLayout == "horizontal")
  {
    for (i = 0; i < this.currTabIdx; i++) dojo.style(dojo.byId("wizard_t" + i + "Img"), "display", "inline");
    for (i = this.currTabIdx; i < this.TAB_COUNT; i++) dojo.style(dojo.byId("wizard_t" + i + "Img"), "display", "none");  	
  }
*/

  //this.calcSubStepToc();

  if (this._onPageShow[this.currTabIdx])
  {
    window[ this._onPageShow[this.currTabIdx] ](this.currTabIdx, this.id);
  }
    
},



/******************************************************************************************
  Called when the back or next button is clicked.
******************************************************************************************/
navWizTab: function(direction)
{
  var i = 0;
  
  //have your custom function return false to keep the user on this page. For example, if there is an invalid field value, do a 'return false', and the wizard will stay on the current page. you will need to show a message or something to let the user know what is going on  
  if (this._onPageBeforeHide[this.currTabIdx])
  {
  	if (direction == "next")
      pgResult = window[ this._onPageBeforeHide[this.currTabIdx] ](this.currTabIdx, this.id);
    
    //on false, don't allow user to go forward, but also do not prevent back
    if ((!pgResult) && (direction == "next")) return;
  }
  
  if (direction == "next")
  {
    this.currTabIdx++;
    while ((!(this.pageVisibilityFlags[this.currTabIdx])) && (((this.currTabIdx) < this.TAB_COUNT)))
    {
   	  this.currTabIdx++;     
    }
  }

  if (direction == "back")
  {
    this.currTabIdx--;
    while ((!(this.pageVisibilityFlags[this.currTabIdx])) && (this.currTabIdx > 0))
    {
      this.currTabIdx--;      
    }
  }

  this.showTab(this.currTabIdx);

},



/******************************************************************************************
  internal function to create the basic wizard framework; this does not populate the wizard
  with user content pages, this only creates the guts of the wizard.
******************************************************************************************/
writeWizardTemplate: function()
{
	var tocRegion;
	var attachNode;
	
	if (this.srcNodeRef)
	  attachNode = this.srcNodeRef;
	else
      attachNode = document.body;
     
        
    if (!(this.fixedSize))
    {
      dojo.style(attachNode, "height", "95%");
	  dojo.style(attachNode, "width", "97%");	  
	 // dojo.style(attachNode, "overflow", "hidden");
    }
    else
    {
      dojo.style(attachNode, "height", this.fixedHeight);
	  dojo.style(attachNode, "width", this.fixedWidth); 
    }
    
	dojo.style(attachNode, "margin", "0");
	dojo.style(attachNode, "padding", "0");
	
	bdrNode = document.createElement("div");
	dojo.attr(bdrNode, "id", this.id + "borderMainNode");
		
	attachNode.appendChild(bdrNode.cloneNode(true));
		  
	var bdrContainer;
	
    bdrContainer = new dijit.layout.BorderContainer({id:this.id + "wizMainContainer",gutters:false, design:"headline",style:"height: 95%; width: 97%; margin: 0; padding: 0;border:1px solid #e3e3e3;"}, dojo.byId(this.id + "borderMainNode"));
	    
	    
	/* table of contents region; for vertical layout will be in 
	   left region, for horizontal layout, will be in top region */	
	tocRegionNode = document.createElement("div");
	dojo.attr(tocRegionNode, "id", this.id + "tocRegionNode");
	
	
	if (this.tocLayout == "vertical")
	  tocRegion = new dijit.layout.ContentPane({region:"left",style:"width:" + this.tocWidth,id:this.id + "tocRegion"}, dojo.byId(this.id + "tocRegionNode"));
	  
    if (this.tocLayout == "horizontal")
	  tocRegion = new dijit.layout.ContentPane({region:"top",style:"height:35px;",id:this.id + "tocRegion"}, dojo.byId(this.id + "tocRegionNode"));	  
	  
	bdrContainer.addChild(tocRegion);
		
	navBg = document.createElement("div");	
	dojo.addClass(tocRegion.domNode, this.tocBackgroundClass);
	dijit.byId(this.id + "tocRegion").domNode.appendChild(navBg);
	
	navBgCont = document.createElement("div");
	dojo.attr(navBgCont, "id", this.id + "wizardNavTabContainer");	
	navBg.appendChild(navBgCont.cloneNode(true));
		
	centerRegionNode = document.createElement("div");                                                            
	dojo.attr(centerRegionNode, "id", this.id + "centerRegionNode");	                                                        
    centerRegion = new dijit.layout.ContentPane({region:"center",id:this.id + "centerRegion"}, dojo.byId(this.id + "centerRegionNode"));
    centerRegion.startup();
    bdrContainer.addChild(centerRegion);
    
    pageStackNode = document.createElement("div");
    dojo.attr(pageStackNode, "id", this.id + "pageStackContainer")
    dijit.byId(this.id + "centerRegion").domNode.appendChild(pageStackNode.cloneNode(true));
    pageStack = new dijit.layout.StackContainer({id: this.id + "mainTabContainer",style:"height:99%;width:99.9%;"}, dojo.byId(this.id + "pageStackContainer"));
    pageStack.startup();

    bottomRegionNode = document.createElement("div");                                         
    dojo.attr(bottomRegionNode, "id", this.id + "bottomRegionNode");                                               
    bottomRegion = new dijit.layout.ContentPane({region:"bottom"}, dojo.byId(this.id + "bottomRegionNode"));
    bottomRegion.startup();    
    bdrContainer.addChild(bottomRegion);	

    buttonArea = document.createElement("div");
    dojo.attr(buttonArea, "id", this.id + "wizardButtonBar");
    
    bottomRegion.domNode.appendChild(buttonArea.cloneNode(true));
    
        
    bBack = document.createElement("button");
    bNext = document.createElement("button");
    bFinish = document.createElement("button");
    bCancel = document.createElement("button");
    dojo.attr(bBack, "id", this.id + "btnBack");
    dojo.attr(bNext, "id", this.id + "btnNext");
    dojo.attr(bFinish, "id", this.id + "btnFinish");
    dojo.attr(bCancel, "id", this.id + "btnCancel");
    bBackText = document.createTextNode("< Back");
    bNextText = document.createTextNode("Next >");
    bFinishText = document.createTextNode("Finish");
    bCancelText = document.createTextNode("Cancel");
    
    bBack.appendChild(bBackText.cloneNode(true));
    bNext.appendChild(bNextText.cloneNode(true));
    bFinish.appendChild(bFinishText.cloneNode(true));
    bCancel.appendChild(bCancelText.cloneNode(true));
    
    dojo.byId(this.id + "wizardButtonBar").appendChild(bBack.cloneNode(true));
    dojo.byId(this.id + "wizardButtonBar").appendChild(bNext.cloneNode(true));
    dojo.byId(this.id + "wizardButtonBar").appendChild(bFinish.cloneNode(true));
    dojo.byId(this.id + "wizardButtonBar").appendChild(bCancel.cloneNode(true));
    
    this.backBtn = new dijit.form.Button({}, dojo.byId(this.id + "btnBack"));
    this.nextBtn = new dijit.form.Button({}, dojo.byId(this.id + "btnNext"));
    this.finishBtn = new dijit.form.Button({}, dojo.byId(this.id + "btnFinish"));
    this.cancelBtn = new dijit.form.Button({}, dojo.byId(this.id + "btnCancel"));

    this.backBtnConnectHandle = dojo.connect(this.backBtn.domNode, "onclick", this, "navBack");
    this.nextBtnConnectHandle = dojo.connect(this.nextBtn.domNode, "onclick", this, "navNext");
    
    if (this.onFinish)
      this.finishBtnConnectHandle = dojo.connect(this.finishBtn.domNode, "onclick", this, window[this.onFinish]);
    
    
    if (this.onCancel)
    {
      this.cancelBtnConnectHandle = dojo.connect(this.cancelBtn.domNode, "onclick", this, window[this.onCancel]);	
    }
    else
    {
      if (this.destroyOnCancel)
	    this.cancelBtnConnectHandle = dojo.connect(this.cancelBtn.domNode, "onclick", this, this.destroy);	
    }

    bdrContainer.startup();
},

navBack: function()
{
  this.navWizTab("back");	
},

navNext: function()
{
  this.navWizTab("next");	
},

/******************************************************************************************
******************************************************************************************/
destroy: function()
{

  dojo.query('[widgetId]', dijit.byId(this.id + "wizMainContainer").domNode).forEach(function(node){
    var widget = dijit.byNode(node);
    if(widget) widget.destroyRecursive();
  });
 
  this.inherited("destroy", arguments);
  dojo.empty(dijit.byId(this.id + "wizMainContainer").domNode);
  
  
}


});






}
